import sys
import math
from string import*


def controlfasta(fas_lst, f_lst): # controls the fasta input
	
	AAcontrol_lst = ['A','R','N','D','C','Q','E','G','H','I','L','K','M','F','P','S','T','W','Y','V']
	
	count = 0

	if len(fas_lst) > 0:
		for x in fas_lst[0]:
			if x in AAcontrol_lst:
				pass
			else:
				count = count + 1
		if count != 0:
			f_lst.append('This is not a fasta sequence!')
	else:
		f_lst.append('You must paste in a fasta sequence!')

	return f_lst



def controlTMH(tm_lst, h_lst, f_lst): # controls the transmembrane helix input
	

	if len(tm_lst) > 0:
		for tmh in tm_lst:
			if tmh == '':
				pass
			else:
				try:
					int(tmh[0])
				except ValueError:
					f_lst.append('Long TM Helix\nHelix ID "'+tmh[0]+'" incorrect,\nHelix ID must be an integer!')
				if tmh[0] in h_lst:
					f_lst.append('Long TM Helix\nHelix ID "'+tmh[0]+'" incorrect,\nHelix ID exists already!')
				if len(tmh) != 3:
					f_lst.append('Long TM Helix\nWrong input!\nInput: HelixID Startresidue Endresidue')
				elif int(tmh[1]) > int(tmh[2]):
					f_lst.append('Long TM Helix\nInput helix "'+tmh[0]+'" incorrect,\nstartresidue is greater than endresidue!')
				elif (int(tmh[2]) - int(tmh[1]))+1 < 15:
					f_lst.append('Long TM Helix\nLong TM helix means at least 15 Residues!\Helix "'+tmh[0]+'" too short!')
				else:
					h_lst.append(tmh[0])
	else:
		f_lst.append('You must specifiy TM segments!')
	
	return (f_lst,h_lst)



def controlsTMH(stm_lst, h_lst, f_lst, sid_lst): # controls the short transmembrane helix input
	
	if len(stm_lst) > 0:
		if len(stm_lst) >= 2:
			if len(stm_lst)%2 == 0:
				for stmh in stm_lst:
					if stmh == '':
						pass
					else:
						try:
							int(stmh[0])
						except ValueError:
							f_lst.append('Short TM Helix\nHelix ID "'+stmh[0]+'" incorrect,\nHelix ID must be an integer!')
						if stmh[0] in h_lst:
							f_lst.append('Short TM Helix\nHelix ID "'+stmh[0]+'" incorrect,\nHelix ID exists already!')
						if len(stmh) != 3:
							f_lst.append('Short TM Helix\nWrong input!\nInput: HelixID Startresidue Endresidue')
						elif int(stmh[1]) > int(stmh[2]):
							f_lst.append('Short TM Helix\nInput helix "'+stmh[0]+'" incorrect,\nstartresidue is greater than endresidue!')
						else:
							h_lst.append(stmh[0])
							sid_lst.append(stmh[0])
			else:
				f_lst.append('Short TM Helix\nWrong input!\nNumber of short TM helices must be even!')
		else:
				f_lst.append('Short TM Helix\nWrong input!\nOnly one short TM helices is not possible!')
	
	return (f_lst,h_lst,sid_lst)


def controlIH(i_lst, h_lst, f_lst,iid_lst): # controls the interface helix input
	
	if len(i_lst) > 0:
		for i in i_lst:
			if i == '':
				pass
			else:
				try:
					 int(i[0])
				except ValueError:
					f_lst.append('Interface Helix\nHelix ID "'+i[0]+'" incorrect,\nHelix ID must be an integer!')
				if i[0] in h_lst:
					f_lst.append('Interface Helix\nHelix ID "'+i[0]+'" incorrect,\nHelix ID exists already!')
				if len(i) != 3:
					f_lst.append('Interface Helix\nWrong input!\nInput: HelixID Startresidue Endresidue')
				elif int(i[1]) > int(i[2]):
					f_lst.append('Interface Helix\nInput helix "'+i[0]+'" incorrect,\nstartresidue is greater than endresidue!')
				else:
					h_lst.append(i[0])
					iid_lst.append(i[0])
	
	return (f_lst,h_lst,iid_lst)




def controlreentrantregions(sr_lst, h_lst, f_lst, sid_lst): # controls the reentrant region input
	
	if len(sr_lst) > 0:
		for sr in sr_lst:
			if sr == '':
				pass
			else:
				if len(sr) != 2:
					f_lst.append('Reentrant Loop\nWrong input!\nInput: HelixID HelixID')
				elif (sr[0] in sid_lst) and (sr[1] in sid_lst):
					f_lst.append('Reentrant Loop\nReentrant Loop between two short helices is not possible!')
				elif (sr[0] not in h_lst):
					f_lst.append('Reentrant Loop\nHelix ID "'+sr[0]+'" not appearing before!')
				elif (sr[1] not in h_lst):
					f_lst.append('Reentrant Loop\nHelix ID "'+sr[1]+'" not appearing before!')
				elif abs(int(sr[0])-int(sr[1])) != 1:
					f_lst.append('Reentrant Loop\nHelix IDs must be consecutive!')
	
	return f_lst



def controlnoncontacts(sn_lst, h_lst, f_lst, iid_lst, sid_lst): # controls the non contact input
	
	if len(sn_lst) > 0:
		if len(sn_lst) <= 2:
			for sn in sn_lst:
				if sn == '':
					pass
				else:
					if (sn not in h_lst):
						f_lst.append('Non contacting Helices\nHelix ID "'+sn+'" not appearing before!')
					elif sn in iid_lst:
						f_lst.append('Non contacting Helices\nHelices must be long TM helices not interface helices!')
					elif sn in sid_lst:
						f_lst.append('Non contacting Helices\nHelices must be long TM helices not short TM helices!')
			if sn_lst[0] != '' and  sn_lst[1] != '':
				if abs(int(sn_lst[0])-int(sn_lst[1])) != 1:
					f_lst.append('Non contacting Helices\nHelix IDs must be consecutive!')
		else:
			f_lst.append('Only 2 non contacting Helices permitted!')
	
	return f_lst


def controltopology(lines): #control of the upload of a topology file

	f_lst = []
	h_lst = []
	stm_lst = []
	ih_lst = []
	rl_lst = []
	nc_lst = []
	nt_lst = []
	id_lst = []
	
	if lines[0][0:4] != 'name':
		f_lst.append('The file is not a topology file,\nthe first line must begin with "name:".')
	else:
		if lines[1][0:8] != 'sequence':
			f_lst.append('The file is not a topology file,\nthe second line must be "sequence".')
		else:
			if lines[2][0:2] != '>>':
				f_lst.append('The file is not a topology file,\nthe third line must be ">>".')
			else:
				if lines.count('>>\n') != 2:
					f_lst.append('The file is not a topology file,\nthe second ">>" sign is missing.')
				else:
					for line in lines:
						if line != '\n':
							l = line.split()
							if l[0] == 'TM':
								h_lst.append((int(l[2]),int(l[3])))
								if int(l[1]) in id_lst:
									f_lst.append('Helix ID '+str(int(l[1]))+'is not unique!')
								else:
									id_lst.append(int(l[1]))
							elif l[0] == 'sTM':
								stm_lst.append((int(l[2]),int(l[3])))
								if int(l[1]) in id_lst:
									f_lst.append('Helix ID '+str(int(l[1]))+'is not unique!')
								else:
									id_lst.append(int(l[1]))
							elif l[0] == 'IH':
								ih_lst.append((int(l[2]),int(l[3])))
								if int(l[1]) in id_lst:
									f_lst.append('Helix ID '+str(int(l[1]))+'is not unique!')
								else:
									id_lst.append(int(l[1]))
							elif l[0] == 'RL':
								rl_lst.append((int(l[1]),int(l[2])))
							elif l[0] == 'NC':
								nc_lst.append((int(l[1]),int(l[2])))
							elif l[0] == 'N-terminus:':
								nt_lst.append(l[1])
					if len(h_lst) == 0:
						f_lst.append('You must specifiy transmembrane segments (TM).')
					else:
						for helix in h_lst:
							if helix[1]-helix[0] < 0:
								f_lst.append('Startresidue larger than endresidue ('+str(helix)+').')
					if len(nt_lst) == 0:
						f_lst.append('You must specifiy N-teminus.\nIf location not known, please write "N-terminus: noinfo".')
					elif len(nt_lst) != 1:
						f_lst.append('Wrong value for N-teminus.\nPossible values are: "periplasm", "cytoplasm" or "noinfo".')
					elif nt_lst[0] != 'periplasm' and nt_lst[0] != 'cytoplasm' and nt_lst[0] != 'noinfo':
						f_lst.append('Wrong value for N-teminus.\nPossible values are: "periplasm", "cytoplasm" or "noinfo".')
					if len(stm_lst)%2 != 0:
						f_lst.append('You must always specify a pair of short transmembrane helices.')
					else:
						for shelix in stm_lst:
							if shelix[1]-shelix[0] < 0:
								f_lst.append('Startresidue larger than endresidue ('+str(shelix)+').')
					if len(ih_lst) != 0:
						for ihelix in ih_lst:
							if ihelix[1]-ihelix[0] < 0:
								f_lst.append('Startresidue larger than endresidue ('+str(ihelix)+').')
					if len(rl_lst) != 0:
						for rls in rl_lst:
							if rls[0] not in id_lst or rls[1] not in id_lst:
								f_lst.append('Reentrant Loop. First specify the helix IDs ('+str(rls)+').')
					if len(nc_lst) != 0:
						if len(nc_lst) != 1:
							f_lst.append('Only one non contact is possible.')
						else:
							if nc_lst[0][0] not in id_lst or nc_lst[0][1] not in id_lst:
								f_lst.append('Non contact. First specify the helix IDs ('+str(rls)+').')
	return f_lst


def controltmx(tmx_l): #control of the upload of a TMX file
	
	f_tmx_lst = [] #faultlist
	n = 0 # counter
	c_tmx = len(tmx_l) # length of file
	
	for l in tmx_l:
		if l.startswith('mypredMain'):
			break
		elif l.startswith('Calling predictor for MSA'):
			break
		else:
			n = n + 1
	
	if c_tmx == n:
		f_tmx_lst.append('The file is not a TMX file!')
	
	return f_tmx_lst




def controluser(fasta_lst, TMH_lst, STMH_lst, IH_lst, RL_lst, NC_lst): # controls the input the user made in the creation window
	
	fault_lst = [] # mistake list
	helixid_lst = [] # list of helix IDs
	ihid_lst = [] # interface helix id list
	stmid_lst = [] # short tm helix id list
	
	faults = controlfasta(fasta_lst, fault_lst)
	faultshelix = controlTMH(TMH_lst, helixid_lst, faults)
	faultshelix1 = controlsTMH(STMH_lst, faultshelix[1], faultshelix[0],stmid_lst)
	faultshelix2 = controlIH(IH_lst, faultshelix1[1], faultshelix1[0],ihid_lst)
	faults1 = controlreentrantregions(RL_lst, faultshelix2[1], faultshelix2[0], faultshelix1[2])
	faults2 = controlnoncontacts(NC_lst,  faultshelix2[1], faults1,faultshelix2[2], faultshelix1[2])
	#faults3 = controlfastafile(fastafilelst,faults2)
	#faults4 = controltmhmmfile(tmhmmfilelst,faults3)
	
	
	
	fasta_lst = []
	TMH_lst = []
	STMH_lst = []
	IH_lst = []
	RL_lst = []
	NC_lst = []
	
	#fastafilelst = []
	#tmhmmfilelst = []
	
	
	return faults2










