import sys
from os import*
import os
from os.path import*
from Tkinter import*
import tkMessageBox
import tkFileDialog


class Helixwindow(object): # helical wheel window
	def __init__(self,hw_image):
		self.childwindow = Toplevel()
		self.childwindow.geometry('609x660')
		self.childwindow.resizable(False,False)
		self.childwindow.protocol("WM_DELETE_WINDOW", self.callback)
		
		self.fhw1 = Frame(self.childwindow, relief=RIDGE)
		self.fhw1.grid(row=0,column=0, sticky=NW)
		
		self.helixview = Canvas(self.fhw1,width=600,height=600,bg='black')
		self.helixview.grid(row=0,column=0, sticky=NW)
		
		self.path1 = getcwd()
		
		self.helixwheel = hw_image
		self.hw = PhotoImage(file=self.path1+'/'+self.helixwheel)
		self.helixview.create_image(0,0,anchor=NW,image=self.hw)
		
		if self.helixwheel.startswith('helixwheeltmx'):
			self.childwindow.title('TMX coloring')
		elif self.helixwheel.startswith('helixwheelcons'):
			self.childwindow.title('Conservation coloring')
		else:
			self.childwindow.title('Property coloring')
			
			
		self.fhw1_2 = Frame(self.childwindow, relief=RIDGE)
		self.fhw1_2.grid(row=1,column=0, sticky=NW)
		
		if self.helixwheel.startswith('helixwheeltmx'):
			self.lc2 = Label(self.fhw1_2, text='Exposed', background='MidnightBlue', width=13, foreground='grey')
			self.lc2.grid(row=0,column=0, sticky=NW, padx=2)
			
			self.lc3 = Label(self.fhw1_2, text='', background='CornflowerBlue', width=13)
			self.lc3.grid(row=0,column=1, sticky=NW, padx=2)
			
			self.lc4 = Label(self.fhw1_2, text='', background='cyan', width=13)
			self.lc4.grid(row=0,column=2, sticky=NW, padx=2)
			
			self.lc5 = Label(self.fhw1_2, text='', background='orange', width=13)
			self.lc5.grid(row=0,column=3, sticky=NW, padx=2)
			
			self.lc6 = Label(self.fhw1_2, text='', background='DarkOrange2', width=12)
			self.lc6.grid(row=0,column=4, sticky=NW, padx=2)
			
			self.lc7 = Label(self.fhw1_2, text='Buried', background='red', width=13)
			self.lc7.grid(row=0,column=5, sticky=NW, padx=2)
		
		elif self.helixwheel.startswith('helixwheelcons'):
			self.lc2 = Label(self.fhw1_2, text='Variable', background='CornflowerBlue', width=16)
			self.lc2.grid(row=0,column=0, sticky=NW, padx=2)
			
			self.lc3 = Label(self.fhw1_2, text='', background='Cyan', width=16)
			self.lc3.grid(row=0,column=1, sticky=NW, padx=2)
			
			self.lc4 = Label(self.fhw1_2, text='', background='grey91', width=15)
			self.lc4.grid(row=0,column=2, sticky=NW, padx=2)
			
			self.lc5 = Label(self.fhw1_2, text='', background='#ffacf5', width=16)
			self.lc5.grid(row=0,column=3, sticky=NW, padx=2)
			
			self.lc6 = Label(self.fhw1_2, text='Conserved', background='VioletRed', width=16)
			self.lc6.grid(row=0,column=4, sticky=NW, padx=2)
			
		else:
			self.lc2 = Label(self.fhw1_2, text='Small', background='light grey', width=12)
			self.lc2.grid(row=0,column=0, sticky=NW, padx=2)
			
			self.lc3 = Label(self.fhw1_2, text='Hydrophobic', background='green', width=13)
			self.lc3.grid(row=0,column=1, sticky=NW, padx=2)
			
			self.lc4 = Label(self.fhw1_2, text='Polar', background='cyan', width=13)
			self.lc4.grid(row=0,column=2, sticky=NW, padx=2)
			
			self.lc5 = Label(self.fhw1_2, text='Polar-aromatic', background='magenta', width=13)
			self.lc5.grid(row=0,column=3, sticky=NW, padx=2)
			
			self.lc6 = Label(self.fhw1_2, text='Basic', background='red', width=13)
			self.lc6.grid(row=0,column=4, sticky=NW, padx=2)
			
			self.lc7 = Label(self.fhw1_2, text='Acidic', background='blue', width=13, foreground='grey')
			self.lc7.grid(row=0,column=5, sticky=NW, padx=2)
		
		self.fhw2 = Frame(self.childwindow, relief=RIDGE)
		self.fhw2.grid(row=2,column=0, sticky=NW)
		
		self.exportbutton = Button(self.fhw2, text='Export', command=self.export_hw, padx=10)
		self.exportbutton.grid(row=0,column=0, sticky=W)
		
		self.previousbutton = Button(self.fhw2, text='<<', command=self.previous_hw, padx=20)
		self.previousbutton.grid(row=0,column=1, sticky=W)
		
		if self.helixwheel.startswith('helixwheeltmx'):
			self.textlabel = self.helixwheel.split('.')[0][0].upper()+self.helixwheel.split('.')[0][1:5]+' '+self.helixwheel.split('.')[0][5].upper()+self.helixwheel.split('.')[0][6:10]+' '+self.helixwheel.split('.')[0][13:]
			self.labelhelix = Label(self.fhw2, text=self.textlabel)
			self.labelhelix.grid(row=0,column=2, sticky=NW, padx=133, pady=8 )
		elif self.helixwheel.startswith('helixwheelcons'):
			self.textlabel = self.helixwheel.split('.')[0][0].upper()+self.helixwheel.split('.')[0][1:5]+' '+self.helixwheel.split('.')[0][5].upper()+self.helixwheel.split('.')[0][6:10]+' '+self.helixwheel.split('.')[0][14:]
			self.labelhelix = Label(self.fhw2, text=self.textlabel)
			self.labelhelix.grid(row=0,column=2, sticky=NW, padx=133, pady=8 )
		else:
			self.textlabel = self.helixwheel.split('.')[0][0].upper()+self.helixwheel.split('.')[0][1:5]+' '+self.helixwheel.split('.')[0][5].upper()+self.helixwheel.split('.')[0][6:10]+' '+self.helixwheel.split('.')[0][10:]
			self.labelhelix = Label(self.fhw2, text=self.textlabel)
			self.labelhelix.grid(row=0,column=2, sticky=NW, padx=133, pady=8 )
			
			
		self.nextbutton = Button(self.fhw2, text='>>', command=self.next_hw, padx=20)
		self.nextbutton.grid(row=0,column=3, sticky=W)
		
		self.quitbutton = Button(self.fhw2, text='Quit', command=self.callback, padx=15)
		self.quitbutton.grid(row=0,column=4, sticky=E)
		
		self.childwindow.mainloop()
	
	
	
	def export_hw(self): # exports the helical wheel with white background as png
			
		try:
			t = access(self.path1+'/'+self.helixwheel[:len(self.helixwheel)-4] +'_1.pov',F_OK)
		except OSError:
			pass
		if t:
			place = tkFileDialog.asksaveasfilename(title='Save file as...')
			if place != ():
				name = place.split('/')
				n = name[len(name)-1]
				p = '/'.join(name[:len(name)-1])
				if ' ' in p:
					p = p.replace(' ','\ ')
				heliximage = self.helixwheel[:len(self.helixwheel)-4] +'_1.pov'
				w = 800
				cmd = 'povray  '+self.path1+'/'+heliximage+' +O'+self.path1+'/'+n+' +W'+str(w)+' +H'+str(w)+' -D +A'
				popen(cmd, 'r')
				cmd1 = 'mv '+self.path1+'/'+n+'.png '+p+'/'
				popen(cmd1, 'r')
		else:
			tkMessageBox.showwarning('Export Problems','Try again later!')
	
	
	

	def previous_hw(self): #takes the previous helical wheel
		pic = self.helixwheel.split('.')
		if self.helixwheel.startswith('helixwheeltmx'):
			pic_nr = int(self.helixwheel.split('.')[0][13:])
		elif self.helixwheel.startswith('helixwheelcons'):
			pic_nr = int(self.helixwheel.split('.')[0][14:])
		else:
			pic_nr = int(self.helixwheel.split('.')[0][10:])
		
		if pic_nr != 1:
			if self.helixwheel.startswith('helixwheeltmx'):
				self.helixwheel = pic[0][:13]+str(pic_nr-1)+'.'+pic[1]
				self.hw.config(file=self.path1+'/'+self.helixwheel)
				self.helixview.create_image(0,0,anchor=NW,image=self.hw)
			
				self.textlabel = self.helixwheel.split('.')[0][0].upper()+self.helixwheel.split('.')[0][1:5]+' '+self.helixwheel.split('.')[0][5].upper()+self.helixwheel.split('.')[0][6:10]+' '+self.helixwheel.split('.')[0][13:]
				self.labelhelix.config(text=self.textlabel)
			elif self.helixwheel.startswith('helixwheelcons'):
				self.helixwheel = pic[0][:14]+str(pic_nr-1)+'.'+pic[1]
				self.hw.config(file=self.path1+'/'+self.helixwheel)
				self.helixview.create_image(0,0,anchor=NW,image=self.hw)
			
				self.textlabel = self.helixwheel.split('.')[0][0].upper()+self.helixwheel.split('.')[0][1:5]+' '+self.helixwheel.split('.')[0][5].upper()+self.helixwheel.split('.')[0][6:10]+' '+self.helixwheel.split('.')[0][14:]
				self.labelhelix.config(text=self.textlabel)
			else:
				self.helixwheel = pic[0][:10]+str(pic_nr-1)+'.'+pic[1]
				self.hw.config(file=self.path1+'/'+self.helixwheel)
				self.helixview.create_image(0,0,anchor=NW,image=self.hw)
			
				self.textlabel = self.helixwheel.split('.')[0][0].upper()+self.helixwheel.split('.')[0][1:5]+' '+self.helixwheel.split('.')[0][5].upper()+self.helixwheel.split('.')[0][6:10]+' '+self.helixwheel.split('.')[0][10:]
				self.labelhelix.config(text=self.textlabel)
		else:
			pass
	
	def next_hw(self): # takes the next helical wheel
		pic1 = self.helixwheel.split('.')
		if self.helixwheel.startswith('helixwheeltmx'):
			pic1_nr = int(self.helixwheel.split('.')[0][13:])
		elif self.helixwheel.startswith('helixwheelcons'):
			pic1_nr = int(self.helixwheel.split('.')[0][14:])
		else:
			pic1_nr = int(self.helixwheel.split('.')[0][10:])

		try:
			t = access(self.path1+'/'+pic1[0][:10]+str(pic1_nr+1)+'.'+pic1[1],F_OK)
		except OSError:
			pass
		if t:
			if self.helixwheel.startswith('helixwheeltmx'):
				self.helixwheel = pic1[0][:13]+str(pic1_nr+1)+'.'+pic1[1]
				self.hw.config(file=self.path1+'/'+self.helixwheel)
				self.helixview.create_image(0,0,anchor=NW,image=self.hw)
			
				self.textlabel = self.helixwheel.split('.')[0][0].upper()+self.helixwheel.split('.')[0][1:5]+' '+self.helixwheel.split('.')[0][5].upper()+self.helixwheel.split('.')[0][6:10]+' '+self.helixwheel.split('.')[0][13:]
				self.labelhelix.config(text=self.textlabel)
			elif self.helixwheel.startswith('helixwheelcons'):
				self.helixwheel = pic1[0][:14]+str(pic1_nr+1)+'.'+pic1[1]
				self.hw.config(file=self.path1+'/'+self.helixwheel)
				self.helixview.create_image(0,0,anchor=NW,image=self.hw)
			
				self.textlabel = self.helixwheel.split('.')[0][0].upper()+self.helixwheel.split('.')[0][1:5]+' '+self.helixwheel.split('.')[0][5].upper()+self.helixwheel.split('.')[0][6:10]+' '+self.helixwheel.split('.')[0][14:]
				self.labelhelix.config(text=self.textlabel)
			else:
				self.helixwheel = pic1[0][:10]+str(pic1_nr+1)+'.'+pic1[1]
				self.hw.config(file=self.path1+'/'+self.helixwheel)
				self.helixview.create_image(0,0,anchor=NW,image=self.hw)
			
				self.textlabel = self.helixwheel.split('.')[0][0].upper()+self.helixwheel.split('.')[0][1:5]+' '+self.helixwheel.split('.')[0][5].upper()+self.helixwheel.split('.')[0][6:10]+' '+self.helixwheel.split('.')[0][10:]
				self.labelhelix.config(text=self.textlabel)
		else:
			pass


	
	def callback(self):
		self.childwindow.destroy()
		
		

def start(hw): # main function
	path = getcwd()
	s = 0
	
	try:
		t = access(path+'/'+hw,F_OK)
	except OSError:
		pass
	if t:
		try:
			PhotoImage(file=path+'/'+hw)
			s = 1
		except TclError:
			pass
		if s:
			x = Helixwindow(hw)
		else:
			tkMessageBox.showwarning('Calculations running...','Please try again in a few seconds!')
	else:
		tkMessageBox.showwarning('Calculations running...','Please try again in a few seconds!')
	
