import sys
# import Numeric
import math
from string import*
import operator
from threading import*
from os import*
from os.path import*


def datainput(infile): # the topology file is read and its content is saved in different dictionaries

	file_obj = file(infile,'r')
	line_lst = file_obj.readlines()
	file_obj.close()
	

	seq_lst=[] # name, sequence and sequence length of the protein
	stm_lst=[] # list of short TM helices
	rl_lst=[]  # list of reentrant loops
	nc_lst=[] # list of non contacting helices
	helix_lst=[] # help list for helix input
	helix_dict={} # dictionary of TM helices and interface helices
	
	seqlines = line_lst[3:].index('>>\n')
	seq = ''
	
	for line in line_lst[3:3+seqlines]:
		l = line.split()
		seq = seq + l[0]
	seq_lst.append((line_lst[0][5:].rstrip(),seq,len(seq))) # sequence list is filled with name, sequence and sequence length of protein
	

	for line in line_lst[seqlines:]:
		if line != '\n':
			l = line.split()
			if l[0] == 'TM':
				helix_lst.append([(int(l[2]),int(l[3])),'tm',l[1]])
			elif l[0] == 'sTM':
				stm_lst.append(((int(l[2]),int(l[3])),'stm',l[1]))
			elif l[0] == 'IH':
				helix_lst.append([(int(l[2]),int(l[3])),'ih',l[1]])
			elif l[0] == 'RL':
				rl_lst.append((int(l[1]),int(l[2])))
			elif l[0] == 'NC':
				if int(l[1]) not in nc_lst:
					nc_lst.append(int(l[1]))
				if  int(l[2]) not in nc_lst:
					nc_lst.append(int(l[2]))
			elif l[0] == 'N-terminus:':
				orientation = l[1]

	nc_lst.sort()

	stm_lst.sort(key=operator.itemgetter(0))

	for stm in stm_lst[:len(stm_lst)-1]:
		if (stm_lst[stm_lst.index(stm)+1][0][0] - stm[0][1]) <= 6:
			helix_lst.append([(stm[0][0],stm_lst[stm_lst.index(stm)+1][0][1]), stm[0][1],stm_lst[stm_lst.index(stm)+1][0][0],stm[1],stm_lst[stm_lst.index(stm)+1][2]])
	
	
	helix_lst.sort(key=operator.itemgetter(0))
	
	if orientation == 'noinfo' or orientation == 'cytoplasm':
		ori = 'c'
	elif orientation == 'periplasm':
		ori = 'p'
	
	for he in helix_lst: # each helix is attachted to an orientation: cytoplasm or periplasm
		if he[1] == 'ih':
			he.append(ori)
		elif he[1] == 'tm' or he[3] == 'stm':
			he.append(ori)
			if ori == 'c':
				ori = 'p'
			else:
				ori = 'c'


	helixcount = 1
	for h in helix_lst: # the helix dict is filled
		if h[1] == 'tm' or h[1]=='ih':
			helix_dict[(helixcount,h[1],h[2],h[3])] = [h[0][0],h[0][1],h[0][1]-h[0][0]+1,round(float(h[0][1]-h[0][0]+1)/3.6,4),round((float(h[0][1]-h[0][0]+1)/3.6)*5.4,4)]
			helixcount = helixcount + 1
		elif  h[3] == 'stm':  # start, end, length (number of residues), turns helix 1, length of whole structure (two short helices above each other with loop in between),turns helix 2, end helix 1, start helix 2
			helix_dict[(helixcount,h[3],h[4],h[5])] = [h[0][0],h[0][1],h[0][1]-h[0][0]+1,round(float(h[1]-h[0][0]+1)/3.6,4),round((((float(h[1]-h[0][0]+1)/3.6)+(float(h[0][1]-h[2]+1)/3.6))*5.4)+2+(((h[2]-h[1])-1)*2.2) ,4), round(float(h[0][1]-h[2]+1)/3.6,4), h[1], h[2]]
			helixcount = helixcount + 1


	return (helix_dict,rl_lst,seq_lst,nc_lst)


def dataevaluation(hd,sl,rll,ncl): # the loop length are calculated, the length of reentrant loops is controled and non contacts are controled

	loop_dict={}
	
	firsth = min(hd.keys())
	lasth = max(hd.keys())
	
	
	firstloop = hd[firsth][0] - 1 # loop length of N-terminus
	lastloop = sl[0][2]-hd[lasth][1]-1 # loop length of C-terminus
	loop_dict[firsth[0]]= firstloop
	loop_dict[lasth[0]+1]= lastloop
	
	sortedkey_lst = hd.keys() # sorted list of helices
	sortedkey_lst.sort(key=operator.itemgetter(0))
	
	for keys in sortedkey_lst: # calculating the loop length between the helices
		if keys[0] == 1:
			pass
		else:
			loop_dict[keys[0]] = hd[keys][0]-hd[sortedkey_lst[sortedkey_lst.index(keys)-1]][1]-1 # loop length between the helices

	
	
	for rl in rll: # delete reentrant loops that are too short, mark remaining reentrant loops in the helix dict
		if loop_dict[rl[1]]<10:
			rll.remove(rl)
			print 'Loop is too short a for reentrant loop, minimum length is 10 residues'
		else:
			for h in hd:
				if rl[0] == int(h[2]):
					if hd[h][len(hd[h])-1] != 'rl':
						hd[h].append('rl')

	
	if len(ncl) == 2: # delete non contacts that are not permitted, save remaining in the non contacts list
		if ncl[1] == int(lasth[2]):
			if (loop_dict[ncl[0]+1] >= 10  and loop_dict[ncl[0]-1] >= 10) or (ncl[0],ncl[1]) in rll:
				pass
			else:
				ncl = []
		elif ncl[0] > 1:
			if (loop_dict[ncl[0]+1] >= 10 and loop_dict[ncl[0]+3] >= 10) or (loop_dict[ncl[0]+1] >= 10 and loop_dict[ncl[0]-1] >= 10) or (loop_dict[ncl[0]+1] >= 10 and  ncl[1]+1 == int(lasth[2])) or (loop_dict[ncl[0]+1] >= 10 and ncl[0]-1 == int(firsth[2])) or (ncl[0],ncl[1]) in rll:
				pass
			else:
				ncl = []
		elif ncl[0] == 1:
			if (loop_dict[ncl[0]+1] >= 10 and loop_dict[ncl[0]+3] >= 10) or (ncl[0],ncl[1]) in rll:
				pass
			else:
				ncl = []
	
	
	return (loop_dict,sortedkey_lst,rll,hd,ncl)





def getting_xcoordinate(hd,skl): # calculating the x coordinates of the helices
	
	xcoordinate_dict = {}

	xstart = 22 # x coordinate of the first the helix
	

	for k in skl:
		if k[1] == 'ih':
			if hd[k][len(hd[k])-1] == 'rl' and skl[skl.index(k)+1][1]=='ih':
				xcoordinate_dict[k] = (xstart,0,2)
				xstart = xstart + 28 + int(math.ceil(hd[k][4]))
			elif hd[k][len(hd[k])-1] == 'rl':
				xcoordinate_dict[k] = (xstart,0,2)
				xstart = xstart + 26 + int(math.ceil(hd[k][4]))
			else:
				xcoordinate_dict[k] = (xstart,0,2)
				xstart = xstart + 9 + int(math.ceil(hd[k][4]))
		elif k[1] == 'tm' or k[1] == 'stm':
			if hd[k][len(hd[k])-1] == 'rl':
				xcoordinate_dict[k] = (xstart,0,2)
				xstart = xstart + 24
			else:
				xcoordinate_dict[k] = (xstart,0,2)
				xstart = xstart + 12


	volume = xcoordinate_dict[max(xcoordinate_dict.keys())][0]+22 # volume we need in the membrane
	
	
	return (xcoordinate_dict, volume)


def getting_ycoordinate(hd,skl,ld,xcd): # calculating the y coordinates of the helices
	
	ycoordinate_dict = {}
	
	ymembrane = 18

	lastloop = max(ld.keys())
	
	firsthelix = min(hd.keys())
	lasthelix =max(hd.keys())

	
	
	if firsthelix[1] == 'ih': # coordinates of the first helix
		if firsthelix[3] == 'p':
			ycoordinate_dict[firsthelix]=(xcd[firsthelix][0],-ymembrane,2)
		else:
			ycoordinate_dict[firsthelix]=(xcd[firsthelix][0],ymembrane,2)
	elif firsthelix[1] == 'tm' or firsthelix[1] == 'stm':
		if ld[firsthelix[0]+1] <= 6:
			if firsthelix[3] == 'p':
				ycoordinate_dict[firsthelix]=(xcd[firsthelix][0],(round(float(hd[skl[skl.index(firsthelix)+1]][4]/2),2))*(-1),2)
			else:
				ycoordinate_dict[firsthelix]=(xcd[firsthelix][0],round(float(hd[skl[skl.index(firsthelix)+1]][4]/2),2),2)
		else:
			if  firsthelix[3] == 'p':
				ycoordinate_dict[firsthelix]=(xcd[firsthelix][0],round(float(hd[firsthelix][4]/2),2)*(-1),2)
			else:
				ycoordinate_dict[firsthelix]=(xcd[firsthelix][0],round(float(hd[firsthelix][4]/2),2),2)
	
	
	if lasthelix[1] == 'ih': # coordinates of the last helix
		if lasthelix[3] == 'p':
			ycoordinate_dict[lasthelix]=(xcd[lasthelix][0],-ymembrane,2)
		else:
			ycoordinate_dict[lasthelix]=(xcd[lasthelix][0],ymembrane,2)
	elif lasthelix[1] == 'tm' or lasthelix[1] == 'stm':
		if ld[lasthelix[0]+1] <= 6:
			if lasthelix[3] == 'p':
				ycoordinate_dict[lasthelix]=(xcd[lasthelix][0],(round(float(hd[skl[skl.index(lasthelix)-1]][4]/2),2))*(-1),2)
			else:
				ycoordinate_dict[lasthelix]=(xcd[lasthelix][0],round(float(hd[skl[skl.index(lasthelix)-1]][4]/2),2),2)
		else:
			if  lasthelix[3] == 'p':
				ycoordinate_dict[lasthelix]=(xcd[lasthelix][0],round(float(hd[lasthelix][4]/2),2)*(-1),2)
			else:
				ycoordinate_dict[lasthelix]=(xcd[lasthelix][0],round(float(hd[lasthelix][4]/2),2),2)
	
	
	
	for k in skl[1:len(skl)-1]: # coordinates of the remaining helices
		if k[1] == 'ih':
			if k[3] == 'p':
				ycoordinate_dict[k]=(xcd[k][0],-ymembrane,2)
			else:
				ycoordinate_dict[k]=(xcd[k][0],ymembrane,2)
		elif k[1] == 'tm' or k[1] == 'stm':
			if ld[k[0]+1] <= 4:
				if abs((hd[k][4]-hd[skl[skl.index(k)+1]][4])/2) > 1.0:
					if hd[k][4] > hd[skl[skl.index(k)+1]][4]:
						if skl[skl.index(k)-1][1] == 'ih':
							if k[3] == 'p':
								ycoordinate_dict[k]=(xcd[k][0],-20,2)
							else:
								ycoordinate_dict[k]=(xcd[k][0],20,2)
						else:
							if k[3] == 'p':
								ycoordinate_dict[k]=(xcd[k][0],round(float(hd[skl[skl.index(k)+1]][4]/2),2)*(-1),2)
							else:
								ycoordinate_dict[k]=(xcd[k][0],round(float(hd[skl[skl.index(k)+1]][4]/2),2),2)
					else:
						if  k[3] == 'p':
							ycoordinate_dict[k]=(xcd[k][0],round(float(hd[k][4]/2),2)*(-1),2)
						else:
							ycoordinate_dict[k]=(xcd[k][0],round(float(hd[k][4]/2),2),2)
				else:
					if  k[3] == 'p':
						ycoordinate_dict[k]=(xcd[k][0],round(float(hd[k][4]/2),2)*(-1),2)
					else:
						ycoordinate_dict[k]=(xcd[k][0],round(float(hd[k][4]/2),2),2)
			else:
				if  k[3] == 'p':
					ycoordinate_dict[k]=(xcd[k][0],round(float(hd[k][4]/2),2)*(-1),2)
				else:
					ycoordinate_dict[k]=(xcd[k][0],round(float(hd[k][4]/2),2),2)

		
	return ycoordinate_dict



def loopcoordinates(coords,hd,ld,skl,rll):# calculating the coordinates of the loops
	
	loopcoords = {}
	firstlastloop = {}
	reentrantloops = {}
	
	# first and last loop of the protein ##############################################
	
	firsthelix = min(coords.keys())
	lasthelix =  max(coords.keys())

	
	firstloop = min(ld.keys())
	lastloop = max(ld.keys())

	
	if firsthelix[1] == 'ih':
		if firsthelix[3] == 'c':
			firstlastloop[firstloop] = (coords[firsthelix][0]-2,coords[firsthelix][1]+4.5,coords[firsthelix][2])
		elif firsthelix[3] == 'p':
			firstlastloop[firstloop] = (coords[firsthelix][0]-2,coords[firsthelix][1]-4.5,coords[firsthelix][2])
	else:
		if firsthelix[3] == 'c':
			firstlastloop[firstloop] = (coords[firsthelix][0],coords[firsthelix][1]+4.5,coords[firsthelix][2])
		elif firsthelix[3] == 'p':
			firstlastloop[firstloop] = (coords[firsthelix][0],coords[firsthelix][1]-4.5,coords[firsthelix][2])
	if lasthelix[1] == 'ih':
		if lasthelix[3] == 'c':
			firstlastloop[lastloop] = (coords[lasthelix][0]+hd[lasthelix][4]+2,coords[lasthelix][1]+4.5,coords[lasthelix][2])
		elif lasthelix[3] == 'p':
			firstlastloop[lastloop] = (coords[lasthelix][0]+hd[lasthelix][4]+2,coords[lasthelix][1]-4.5,coords[lasthelix][2])
	else:
		if lasthelix[3] == 'c':
			firstlastloop[lastloop] = (coords[lasthelix][0],coords[lasthelix][1]-hd[lasthelix][4]-4.5,coords[lasthelix][2])
		elif lasthelix[3] == 'p':
			firstlastloop[lastloop] = (coords[lasthelix][0],coords[lasthelix][1]+hd[lasthelix][4]+4.5,coords[lasthelix][2])
	
	# reentrant loops ####################################################################
	
	if len(rll) > 0:
		for helix in skl[:len(skl)-1]:
			if hd[helix][len(hd[helix])-1] == 'rl':
				if helix[1] == 'ih' and skl[skl.index(helix)+1][1] == 'ih':
					xcoord1 = coords[helix][0] + hd[helix][4] + 2
					xcoord2 = coords[skl[skl.index(helix)+1]][0] -2
					if (float(ld[helix[0]+1]-10)/2)%2 == 0:
						n1 = (ld[helix[0]+1]-10)/2
						n2 = n1
						nr = 3
					else:
						n1 = int(math.floor((ld[helix[0]+1]-10)/2))
						n2 = n1
						nr = 4
					if helix[3] == 'p':
						ycoord1 = coords[helix][1] - 4
						ycoord2 = coords[skl[skl.index(helix)+1]][1] - 4
					elif helix[3] == 'c':
						ycoord1 = coords[helix][1] + 4
						ycoord2 = coords[skl[skl.index(helix)+1]][1] + 4
				elif helix[1] == 'ih':
					xcoord1 = coords[helix][0] + hd[helix][4] + 2
					xcoord2 = coords[skl[skl.index(helix)+1]][0]
					if (float(ld[helix[0]+1]-10)/2)%2 == 0:
						n1 = (ld[helix[0]+1]-10)/2
						n2 = n1
						nr = 3
					else:
						n1 = int(math.floor((ld[helix[0]+1]-10)/2))
						n2 = n1
						nr = 4
					if helix[3] == 'p':
						ycoord1 = coords[helix][1] - 4
						ycoord2 = coords[skl[skl.index(helix)+1]][1] - 4
					elif helix[3] == 'c':
						ycoord1 = coords[helix][1] + 4
						ycoord2 = coords[skl[skl.index(helix)+1]][1] + 4
				else:	
					xcoord1 = coords[helix][0]
					xcoord2 = coords[skl[skl.index(helix)+1]][0]
					if helix[3] == 'p':
						ycoord1 = coords[helix][1] + hd[helix][4] + 4
						ycoord2 = coords[skl[skl.index(helix)+1]][1] + 4
						balanceresidues = round(abs(ycoord1-ycoord2)/4,0)
						if ycoord1 <= ycoord2:
							if (float(ld[helix[0]+1]-10-balanceresidues)/2)%2 == 0:
								n1 = (ld[helix[0]+1]-10-balanceresidues)/2
								n2 = n1 + balanceresidues
								nr = 3
							else:
								n1 = int(math.floor((ld[helix[0]+1]-10-balanceresidues)/2))
								n2 = n1 + balanceresidues
								nr = 4
						else:
							if ((ld[helix[0]+1]-10-balanceresidues)/2)%2 == 0:
								n2 = (ld[helix[0]+1]-10-balanceresidues)/2
								n1 = n2 + balanceresidues
								nr = 3
							else:
								n2 = int(math.floor((ld[helix[0]+1]-10-balanceresidues)/2))
								n1 = n2 + balanceresidues
								nr = 4
					elif helix[3] == 'c':
						ycoord1 = coords[helix][1] - hd[helix][4] - 4
						ycoord2 = coords[skl[skl.index(helix)+1]][1] - 4
						balanceresidues = round(abs(ycoord1-ycoord2)/4,0)
						if ycoord1 >= ycoord2:
							if (float(ld[helix[0]+1]-10-balanceresidues)/2)%2 == 0:
								n1 = (ld[helix[0]+1]-10-balanceresidues)/2
								n2 = n1 + balanceresidues
								nr = 3
							else:
								n1 = int(math.floor((ld[helix[0]+1]-10-balanceresidues)/2))
								n2 = n1 + balanceresidues
								nr = 4
						else:
							if ((ld[helix[0]+1]-10-balanceresidues)/2)%2 == 0:
								n2 = (ld[helix[0]+1]-10-balanceresidues)/2
								n1 = n2 + balanceresidues
								nr = 3
							else:
								n2 = int(math.floor((ld[helix[0]+1]-10-balanceresidues)/2))
								n1 = n2 + balanceresidues
								nr = 4

				reentrantloops[helix[0]+1] = (xcoord1,ycoord1,2,xcoord2,ycoord2,2,int(n1),int(n2),nr)


	
	
	# remaining loops ####################################################################
	
	
	
	for helix in skl[:len(skl)-1]:
		if ld[helix[0]+1] > 4:
			w = 180
			if helix[1] == 'ih' and skl[skl.index(helix)+1][1] == 'ih' :
				xcoord1 = coords[helix][0] + hd[helix][4] + 1.5
				xcoord2 = coords[skl[skl.index(helix)+1]][0]-1.5
				if (float(ld[helix[0]+1]-3)/2)%2 == 0:
					n1 = (ld[helix[0]+1]-3)/2
					n2 = n1
					nr = 2
					ra = 3
				else:
					n1 = int(math.floor((ld[helix[0]+1]-4)/2))
					n2 = n1
					nr = 3
					ra = 3
				if helix[3] == 'p':
					ycoord1 = coords[helix][1] - 4
					ycoord2 = coords[skl[skl.index(helix)+1]][1] - 4
				elif helix[3] == 'c':
					ycoord1 = coords[helix][1] + 4
					ycoord2 = coords[skl[skl.index(helix)+1]][1] + 4
			elif helix[1] == 'ih':
				xcoord1 = coords[helix][0] + hd[helix][4] + 2
				xcoord2 = coords[skl[skl.index(helix)+1]][0]
				if helix[3] == 'p':
					ycoord1 = coords[helix][1]- 4
					ycoord2 = coords[skl[skl.index(helix)+1]][1] - 4
					balanceresidues = round(abs(ycoord1-ycoord2)/4,0)
					if ycoord1 <= ycoord2:
						if (float(ld[helix[0]+1]-3-balanceresidues)/2)%2 == 0:
							n1 = (ld[helix[0]+1]-3-balanceresidues)/2
							n2 = n1 + balanceresidues
							nr = 2
							ra = 3.5
						else:
							n1 = int(math.floor((ld[helix[0]+1]-4-balanceresidues)/2))
							n2 = n1 + balanceresidues
							nr = 3
							ra = 3.5
					else:
						if (float(ld[helix[0]+1]-3-balanceresidues)/2)%2 == 0:
							n2 = (ld[helix[0]+1]-3-balanceresidues)/2
							n1 = n2 + balanceresidues
							nr = 2
							ra = 3.5
						else:
							n2 = int(math.floor((ld[helix[0]+1]-4-balanceresidues)/2))
							n1= n2 + balanceresidues
							nr = 3
							ra = 3.5
						
				elif helix[3] == 'c':
					ycoord1 = coords[helix][1] + 4
					ycoord2 = coords[skl[skl.index(helix)+1]][1] + 4
					balanceresidues = round(abs(ycoord1-ycoord2)/4,0)
					if ycoord1 <= ycoord2:
						if (float(ld[helix[0]+1]-3-balanceresidues)/2)%2 == 0:
							n2 = (ld[helix[0]+1]-3-balanceresidues)/2
							n1 = n2 + balanceresidues
							nr = 2
							ra = 3.5
						else:
							n2 = int(math.floor((ld[helix[0]+1]-4-balanceresidues)/2))
							n1 = n2 + balanceresidues
							nr = 3
							ra = 3.5
					else:
						if (float(ld[helix[0]+1]-3-balanceresidues)/2)%2 == 0:
							n1 = (ld[helix[0]+1]-3-balanceresidues)/2
							n2 = n1 + balanceresidues
							nr = 2
							ra = 3.5
						else:
							n1 = int(math.floor((ld[helix[0]+1]-4-balanceresidues)/2))
							n2 = n1 + balanceresidues
							nr = 3
							ra = 3.5
			else:
				xcoord1 = coords[helix][0]
				xcoord2 = coords[skl[skl.index(helix)+1]][0]
				if helix[3] == 'p':
					ycoord1 = coords[helix][1] + hd[helix][4] + 4
					ycoord2 = coords[skl[skl.index(helix)+1]][1] + 4
					balanceresidues = round(abs(ycoord1-ycoord2)/4,0)
					if ycoord1 <= ycoord2:
						if (float(ld[helix[0]+1]-4-balanceresidues)/2)%2 == 0:
							n2 = (ld[helix[0]+1]-4-balanceresidues)/2
							n1 = n2 + balanceresidues
							nr = 3
							ra = 6
						else:
							n2 = int(math.floor((ld[helix[0]+1]-5-balanceresidues)/2))
							n1 = n2 + balanceresidues
							nr = 4
							ra = 6
					else:
						if (float(ld[helix[0]+1]-4-balanceresidues)/2)%2 == 0:
							n1 = (ld[helix[0]+1]-4-balanceresidues)/2
							n2 = n1 + balanceresidues
							nr = 3
							ra = 6
						else:
							n1 = int(math.floor((ld[helix[0]+1]-5-balanceresidues)/2))
							n2 = n1 + balanceresidues
							nr = 4
							ra = 6
						
				elif helix[3] == 'c':
					ycoord1 = coords[helix][1] - hd[helix][4] - 4
					ycoord2 = coords[skl[skl.index(helix)+1]][1] - 4
					balanceresidues = round(abs(ycoord1-ycoord2)/4,0)
					if ycoord1 >= ycoord2:
						if (float(ld[helix[0]+1]-4-balanceresidues)/2)%2 == 0:
							n2 = (ld[helix[0]+1]-4-balanceresidues)/2
							n1 = n2 + balanceresidues
							nr = 3
							ra = 6
						else:
							n2 = int(math.floor((ld[helix[0]+1]-5-balanceresidues)/2))
							n1 = n2 + balanceresidues
							nr = 4
							ra = 6
					else:
						if (float(ld[helix[0]+1]-4-balanceresidues)/2)%2 == 0:
							n1 = (ld[helix[0]+1]-4-balanceresidues)/2
							n2 = n1 + balanceresidues
							nr = 3
							ra = 6
						else:
							n1 = int(math.floor((ld[helix[0]+1]-5-balanceresidues)/2))
							n2 = n1 + balanceresidues
							nr = 4
							ra = 6
			if reentrantloops.has_key(helix[0]+1):
				pass
			else:
				loopcoords[helix[0]+1] = (xcoord1,ycoord1,2,xcoord2,ycoord2,2,int(n1),int(n2),ld[helix[0]+1],ra,nr,w)
		else:
			if helix[1] == 'ih' and skl[skl.index(helix)+1][1] == 'ih':
				xcoord1 = coords[helix][0] + hd[helix][4] + 2
				xcoord2 = coords[skl[skl.index(helix)+1]][0] -2
				n1 = 0
				n2 = 0
				nr = ld[helix[0]+1]-1
				ra = 2.5
				w = 180
				if helix[3] == 'p':
					ycoord1 = coords[helix][1] - 4
					ycoord2 = coords[skl[skl.index(helix)+1]][1] - 4
				elif helix[3] == 'c':
					ycoord1 = coords[helix][1] + 4
					ycoord2 = coords[skl[skl.index(helix)+1]][1] + 4
			elif helix[1] == 'ih':
				xcoord1 = coords[helix][0] + hd[helix][4] + 2
				xcoord2 = coords[skl[skl.index(helix)+1]][0]
				n1 = 0
				n2 = 0
				nr = ld[helix[0]+1]-1
				ra = 3.5
				w = 180
				if helix[3] == 'p':
					ycoord1 = coords[helix][1] - 4.2
					ycoord2 = coords[skl[skl.index(helix)+1]][1] - 4.2
				elif helix[3] == 'c':
					ycoord1 = coords[helix][1] + 4.2
					ycoord2 = coords[skl[skl.index(helix)+1]][1] + 4.2
			else:
				xcoord1 = coords[helix][0]
				xcoord2 = coords[skl[skl.index(helix)+1]][0]
				n1 = 0
				n2 = 0
				nr = ld[helix[0]+1]-1
				w = 180
				ra = 4.5
				if helix[3] == 'p':
					ycoord1 = coords[helix][1] + hd[helix][4] + 4
					ycoord2 = coords[skl[skl.index(helix)+1]][1] + 4
				elif helix[3] == 'c':
					ycoord1 = coords[helix][1] - hd[helix][4] - 4
					ycoord2 = coords[skl[skl.index(helix)+1]][1] - 4
			if reentrantloops.has_key(helix[0]+1):
				pass
			else:
				loopcoords[helix[0]+1] = (xcoord1,ycoord1,2,xcoord2,ycoord2,2,int(n1),int(n2),ld[helix[0]+1],ra,nr,w)
	
	return (firstlastloop,reentrantloops,loopcoords)



def non_contacts_coords(ncl,ycoords,flc,rlc,lcoords,ld,rll,skl): # calculating the coordinates of the non contacts (shifted helices)
	
	#non contacting helices##############################
	
	
	firsthelix = min(ycoords.keys())
	lasthelix = max(ycoords.keys())
	
	nccoord_dict = {} # dict with coordiantes of non contacts
	
	for yc in ycoords:
		if int(yc[2]) == ncl[0]:
			startnc = yc # first helix of non contact
			if startnc == firsthelix:
				pass
			else:
				prestartnc = skl[skl.index(startnc)-1] # precursor of first helix of non contact
		elif  int(yc[2]) == ncl[1]:
			endnc = yc # second helix of non contact
			if endnc == lasthelix:
				pass
			else:
				postendnc = skl[skl.index(endnc)+1] # successor of second helix of non contact

	
	if startnc == firsthelix: # coordinates if the first helix is the first helix of the non contact
		if (ncl[0],ncl[1]) in rll:
			pass
		elif ld[ncl[0]+1] >= 10  and ld[ncl[0]+3] >= 10 and (postendnc[1] != 'ih' and postendnc[1] != 'stm'):
			
			nccoord_dict[endnc] = (ycoords[postendnc][0],ycoords[endnc][1],ycoords[endnc][2])
			nccoord_dict[postendnc] = (ycoords[endnc][0],ycoords[postendnc][1],ycoords[postendnc][2])
	
	elif endnc == lasthelix:  # coordinates if the last helix is the second helix of the non contact
		if (ncl[0],ncl[1]) in rll:
			pass
		elif ld[ncl[0]+1] >= 10  and ld[ncl[0]-1] >= 10 and (prestartnc[1] != 'ih' and prestartnc[1] != 'stm'):
			
			nccoord_dict[startnc] = (ycoords[prestartnc][0],ycoords[startnc][1],ycoords[startnc][2])
			nccoord_dict[prestartnc] = (ycoords[startnc][0],ycoords[prestartnc][1],ycoords[prestartnc][2])
	else:
		if (ncl[0],ncl[1]) in rll:
			pass
		elif ld[ncl[0]+1] >= 10 and ld[ncl[0]+3] >= 10 and (postendnc[1] != 'ih' and postendnc[1] != 'stm'):

			nccoord_dict[endnc] = (ycoords[postendnc][0],ycoords[endnc][1],ycoords[endnc][2])
			nccoord_dict[postendnc] = (ycoords[endnc][0],ycoords[postendnc][1],ycoords[postendnc][2])
		
		elif  ld[ncl[0]+1] >= 10  and ld[ncl[0]-1] >= 10 and (prestartnc[1] != 'ih' and prestartnc[1] != 'stm'):
			
			nccoord_dict[startnc] = (ycoords[prestartnc][0],ycoords[startnc][1],ycoords[startnc][2])
			nccoord_dict[prestartnc] = (ycoords[startnc][0],ycoords[prestartnc][1],ycoords[prestartnc][2])
		
		elif ld[ncl[0]+1] >= 10 and ncl[1]+1 == int(lasthelix[2]) and (postendnc[1] != 'ih' and postendnc[1] != 'stm'):

			nccoord_dict[endnc] = (ycoords[postendnc][0],ycoords[endnc][1],ycoords[endnc][2])
			nccoord_dict[postendnc] = (ycoords[endnc][0],ycoords[postendnc][1],ycoords[postendnc][2])
			
		elif ld[ncl[0]+1] >= 10 and ncl[0]-1 == int(firsthelix[2]) and (prestartnc[1] != 'ih' and prestartnc[1] != 'stm'):
			
			nccoord_dict[startnc] = (ycoords[prestartnc][0],ycoords[startnc][1],ycoords[startnc][2])
			nccoord_dict[prestartnc] = (ycoords[startnc][0],ycoords[prestartnc][1],ycoords[prestartnc][2])

	
	#loops between non contacts###########################################
	
	firstloop = min(ld.keys())
	lastloop = max(ld.keys())	
	
	ncloop_dict = {}

	if len(nccoord_dict.keys()) > 0:
		ncc = nccoord_dict.keys()
		ncc.sort(key=operator.itemgetter(0))
		if ncc[1] == startnc: # the first helix of the non contact and its precursor are shifted
			ncloop = ncc[1][0] + 1
			ncloop_dict[ncloop] = (nccoord_dict[ncc[1]][0],lcoords[ncloop][1],lcoords[ncloop][2],lcoords[ncloop][3],lcoords[ncloop][4],lcoords[ncloop][5],lcoords[ncloop][6]-2,lcoords[ncloop][7]-2,lcoords[ncloop][8],12,lcoords[ncloop][10]+4,lcoords[ncloop][11])
			prencloop = ncc[1][0]-1
			if prencloop == firstloop:
				ncloop_dict[prencloop] = (nccoord_dict[ncc[0]][0],flc[prencloop][1],flc[prencloop][2])
			else:
				ncloop_dict[prencloop] = (lcoords[prencloop][0],lcoords[prencloop][1],lcoords[prencloop][2],nccoord_dict[ncc[0]][0],lcoords[prencloop][4],lcoords[prencloop][5],lcoords[prencloop][6]-2,lcoords[prencloop][7]-2,lcoords[prencloop][8],12,lcoords[prencloop][10]+4,lcoords[prencloop][11])
		elif ncc[0] == endnc: # the last helix of the non contact and its successor are shifted
			ncloop = ncc[0][0]
			ncloop_dict[ncloop] = (lcoords[ncloop][0],lcoords[ncloop][1],lcoords[ncloop][2],nccoord_dict[ncc[0]][0],lcoords[ncloop][4],lcoords[ncloop][5],lcoords[ncloop][6]-2,lcoords[ncloop][7]-2,lcoords[ncloop][8],12,lcoords[ncloop][10]+4,lcoords[ncloop][11])
			postncloop = ncc[0][0]+2
			if postncloop == lastloop:
				ncloop_dict[postncloop] = (nccoord_dict[ncc[1]][0],flc[postncloop][1],flc[postncloop][2])
			else:
				ncloop_dict[postncloop] = (nccoord_dict[ncc[1]][0],lcoords[postncloop][1],lcoords[postncloop][2],lcoords[postncloop][3],lcoords[postncloop][4],lcoords[postncloop][5],lcoords[postncloop][6]-2,lcoords[postncloop][7]-2,lcoords[postncloop][8],12,lcoords[postncloop][10]+4,lcoords[postncloop][11])
	
	return (nccoord_dict,ncloop_dict)


def calarrayforhelixwheel(hd,sl): #calculates the pov colorarray with poperty coloring
	
	seq_dict = {}
	color_dict = {}
	
	for helix in hd:
		if helix[1] == 'tm' or helix[1] == 'ih':
			start = hd[helix][0]
			end = hd[helix][1]
			helixseq = sl[0][1][start-1:end]
			
			for r in helixseq:
				if seq_dict.has_key(int(helix[2])):
					seq_dict[int(helix[2])].append(str(start)+r)
					start  = start + 1
				else:
					seq_dict[int(helix[2])] = [str(start)+r]
					start  = start + 1
				if r == 'V' or r == 'F' or r == 'I' or r == 'L' or r == 'M':
					if color_dict.has_key(int(helix[2])):
						color_dict[int(helix[2])].append('Green')
					else:
						color_dict[int(helix[2])] = ['Green']
				elif r == 'A' or r == 'G':
					if color_dict.has_key(int(helix[2])):
						color_dict[int(helix[2])].append('Grey')
					else:
						color_dict[int(helix[2])] = ['Grey']
				elif r == 'C' or r == 'P' or r == 'H' or r == 'N' or r == 'Q' or r == 'S' or r == 'T':
					if color_dict.has_key(int(helix[2])):
						color_dict[int(helix[2])].append('Cyan')
					else:
						color_dict[int(helix[2])] = ['Cyan']
				elif r == 'Y' or r == 'W':
					if color_dict.has_key(int(helix[2])):
						color_dict[int(helix[2])].append('Magenta')
					else:
						color_dict[int(helix[2])] = ['Magenta']
				elif r == 'D' or r == 'E':
					if color_dict.has_key(int(helix[2])):
						color_dict[int(helix[2])].append('Red')
					else:
						color_dict[int(helix[2])] = ['Red']
				elif r == 'K' or r == 'R':
					if color_dict.has_key(int(helix[2])):
						color_dict[int(helix[2])].append('Blue')
					else:
						color_dict[int(helix[2])] = ['Blue']
		
		elif helix[1] == 'stm':
			start1 = hd[helix][0]
			end1 = hd[helix][6]
			start2 = hd[helix][7]
			end2 = hd[helix][1]
			helixseq1 = sl[0][1][start1-1:end1]
			helixseq2 = sl[0][1][start2-1:end2]

			for r1 in helixseq1:
				if seq_dict.has_key(int(helix[2])-1):
					seq_dict[int(helix[2])-1].append(str(start1)+r1)
					start1  = start1 + 1
				else:
					seq_dict[int(helix[2])-1] = [str(start1)+r1]
					start1  = start1 + 1
				if r1 == 'V' or r1 == 'F' or r1 == 'I' or r1 == 'L' or r1 == 'M':
					if color_dict.has_key(int(helix[2])-1):
						color_dict[int(helix[2])-1].append('Green')
					else:
						color_dict[int(helix[2])-1] = ['Green']
				elif r1 == 'A' or r1 == 'G':
					if color_dict.has_key(int(helix[2])-1):
						color_dict[int(helix[2])-1].append('Grey')
					else:
						color_dict[int(helix[2])-1] = ['Grey']
				elif r1 == 'C' or r1 == 'P' or r1 == 'H' or r1 == 'N' or r1 == 'Q' or r1 == 'S' or r1 == 'T':
					if color_dict.has_key(int(helix[2])-1):
						color_dict[int(helix[2])-1].append('Cyan')
					else:
						color_dict[int(helix[2])-1] = ['Cyan']
				elif r1 == 'Y' or r1 == 'W':
					if color_dict.has_key(int(helix[2])-1):
						color_dict[int(helix[2])-1].append('Magenta')
					else:
						color_dict[int(helix[2])-1] = ['Magenta']
				elif r1 == 'D' or r1 == 'E':
					if color_dict.has_key(int(helix[2])-1):
						color_dict[int(helix[2])-1].append('Red')
					else:
						color_dict[int(helix[2])-1] = ['Red']
				elif r1 == 'K' or r1 == 'R':
					if color_dict.has_key(int(helix[2])-1):
						color_dict[int(helix[2])-1].append('Blue')
					else:
						color_dict[int(helix[2])-1] = ['Blue']
				
			
			for r2 in helixseq2:
				if seq_dict.has_key(int(helix[2])):
					seq_dict[int(helix[2])].append(str(start2)+r2)
					start2  = start2 + 1
				else:
					seq_dict[int(helix[2])] = [str(start2)+r2]
					start2  = start2 + 1
				if r2 == 'V' or r2 == 'F' or r2 == 'I' or r2 == 'L' or r2 == 'M':
					if color_dict.has_key(int(helix[2])):
						color_dict[int(helix[2])].append('Green')
					else:
						color_dict[int(helix[2])] = ['Green']
				elif r2 == 'A' or r2 == 'G':
					if color_dict.has_key(int(helix[2])):
						color_dict[int(helix[2])].append('Grey')
					else:
						color_dict[int(helix[2])] = ['Grey']
				elif r2 == 'C' or r2 == 'P' or r2 == 'H' or r2 == 'N' or r2 == 'Q' or r2 == 'S' or r2 == 'T':
					if color_dict.has_key(int(helix[2])):
						color_dict[int(helix[2])].append('Cyan')
					else:
						color_dict[int(helix[2])] = ['Cyan']
				elif r2 == 'Y' or r2 == 'W':
					if color_dict.has_key(int(helix[2])):
						color_dict[int(helix[2])].append('Magenta')
					else:
						color_dict[int(helix[2])] = ['Magenta']
				elif r2 == 'D' or r2 == 'E':
					if color_dict.has_key(int(helix[2])):
						color_dict[int(helix[2])].append('Red')
					else:
						color_dict[int(helix[2])] = ['Red']
				elif r2 == 'K' or r2 == 'R':
					if color_dict.has_key(int(helix[2])):
						color_dict[int(helix[2])].append('Blue')
					else:
						color_dict[int(helix[2])] = ['Blue']
	
	return (seq_dict,color_dict)


def readTMX(tmxfile): # the TMX file is read and its content is processed

	tmx_file_obj = file(tmxfile,'r')
	tmx_line_lst = tmx_file_obj.readlines()
	tmx_file_obj.close()
	
	expose_dict = {} #exposure dict
	cons_dict = {} #conservation dict
	
	for l in tmx_line_lst[0:10]:
		if l.startswith('mypredMain'):
			proteinname = l.split()[len(l.split())-1]
		elif l.startswith('Calling predictor'):
			proteinname = l.split()[len(l.split())-1][0:3]
	for l in tmx_line_lst:
		if l.startswith(proteinname):
			w = l.split()
			if len(w) == 8:
				cons_dict[int(w[2])] = (float(w[4]),w[3])
				expose_dict[int(w[2])] = (w[6],float(w[7]),w[3])
			elif len(w) == 9:
				cons_dict[int(w[2])] = (float(w[4]),w[3])
				expose_dict[int(w[2])] = (w[6],float(w[8]),w[3])
	
	
	return (expose_dict,cons_dict)
	


def caltmxarrayforhelixwheel(hd,sl,e_dict,c_dict): #calculates the pov colorarray with tmx and conservation coloring
	
	seq_dict = {}
	tmx_dict = {}
	conscol_dict = {}

	
	for helix in hd:
		if helix[1] == 'tm' or helix[1] == 'ih':
			start = hd[helix][0]
			labelstart = hd[helix][0]
			consstart = hd[helix][0]
			end = hd[helix][1]
			helixseq = sl[0][1][start-1:end]

			for r in helixseq:
				if seq_dict.has_key(int(helix[2])):
					seq_dict[int(helix[2])].append(str(labelstart)+r)
					labelstart  = labelstart + 1
				else:
					seq_dict[int(helix[2])] = [str(start)+r]
					labelstart  = labelstart + 1
				if r == e_dict[start-1][2]:
					if e_dict[start-1][0] == 'B':
						if e_dict[start-1][1] > 0.0 and e_dict[start-1][1] <= 0.5:
							if tmx_dict.has_key(int(helix[2])):
								tmx_dict[int(helix[2])].append('OrangeRed')
								start = start + 1
							else:
								tmx_dict[int(helix[2])] = ['OrangeRed']
								start = start + 1
						elif e_dict[start-1][1] <= 0.0:
							if tmx_dict.has_key(int(helix[2])):
								tmx_dict[int(helix[2])].append('Orange')
								start = start + 1
							else:
								tmx_dict[int(helix[2])] = ['Orange']
								start = start + 1
						elif e_dict[start-1][1] > 0.5:
							if tmx_dict.has_key(int(helix[2])):
								tmx_dict[int(helix[2])].append('Red')
								start = start + 1
							else:
								tmx_dict[int(helix[2])] = ['Red']
								start = start + 1
					elif e_dict[start-1][0] == 'E':
						if e_dict[start-1][1] > 0.0 and e_dict[start-1][1] <= 0.5:
							if tmx_dict.has_key(int(helix[2])):
								tmx_dict[int(helix[2])].append('SlateBlue')
								start = start + 1
							else:
								tmx_dict[int(helix[2])] = ['SlateBlue']
								start = start + 1
						elif e_dict[start-1][1] <= 0.0:
							if tmx_dict.has_key(int(helix[2])):
								tmx_dict[int(helix[2])].append('Cyan')
								start = start + 1
							else:
								tmx_dict[int(helix[2])] = ['Cyan']
								start = start + 1
						elif e_dict[start-1][1] > 0.5:
							if tmx_dict.has_key(int(helix[2])):
								tmx_dict[int(helix[2])].append('NewMidnightBlue')
								start = start + 1
							else:
								tmx_dict[int(helix[2])] = ['NewMidnightBlue']
								start = start + 1
					if c_dict[consstart-1][0] < -0.3 :
						if conscol_dict.has_key(int(helix[2])):
							conscol_dict[int(helix[2])].append('SlateBlue')
							consstart = consstart + 1
						else:
							conscol_dict[int(helix[2])] = ['SlateBlue']
							consstart = consstart + 1
					elif c_dict[consstart-1][0] >= -0.3 and c_dict[consstart-1][0] < 0.0:
						if conscol_dict.has_key(int(helix[2])):
							conscol_dict[int(helix[2])].append('Cyan')
							consstart = consstart + 1
						else:
							conscol_dict[int(helix[2])] = ['Cyan']
							consstart = consstart + 1
					elif c_dict[consstart-1][0] >= 0.0 and c_dict[consstart-1][0] < 0.3:
						if conscol_dict.has_key(int(helix[2])):
							conscol_dict[int(helix[2])].append('Quartz')
							consstart = consstart + 1
						else:
							conscol_dict[int(helix[2])] = ['Quartz']
							consstart = consstart + 1
					elif c_dict[consstart-1][0] >= 0.3 and c_dict[consstart-1][0] < 0.8 :
						if conscol_dict.has_key(int(helix[2])):
							conscol_dict[int(helix[2])].append('NeonPink')
							consstart = consstart + 1
						else:
							conscol_dict[int(helix[2])] = ['NeonPink']
							consstart = consstart + 1
					elif c_dict[consstart-1][0] >= 0.8 :
						if conscol_dict.has_key(int(helix[2])):
							conscol_dict[int(helix[2])].append('DarkPurple')
							consstart = consstart + 1
						else:
							conscol_dict[int(helix[2])] = ['DarkPurple']
							consstart = consstart + 1
				else:
					if tmx_dict.has_key(int(helix[2])):
						tmx_dict[int(helix[2])].append('Green')
						start = start + 1
					else:
						tmx_dict[int(helix[2])] = ['Green']
						start = start + 1
					if conscol_dict.has_key(int(helix[2])):
						conscol_dict[int(helix[2])].append('Green')
						consstart = consstart + 1
					else:
						conscol_dict[int(helix[2])] = ['Green']
						consstart = consstart + 1

		
		elif helix[1] == 'stm':
			start1 = hd[helix][0]
			start_1 = hd[helix][0]
			consstart_1 = hd[helix][0]
			end1 = hd[helix][6]
			start2 = hd[helix][7]
			start_2 = hd[helix][7]
			consstart_2 = hd[helix][0]
			end2 = hd[helix][1]
			helixseq1 = sl[0][1][start1-1:end1]
			helixseq2 = sl[0][1][start2-1:end2]
			
			for r1 in helixseq1:
				if seq_dict.has_key(int(helix[2])-1):
					seq_dict[int(helix[2])-1].append(str(start1)+r1)
					start1  = start1 + 1
				else:
					seq_dict[int(helix[2])-1] = [str(start1)+r1]
					start1  = start1 + 1
				if r1 == e_dict[start_1-1][2]:
					if e_dict[start_1-1][0] == 'B':
						if e_dict[start_1-1][1] > 0.0 and e_dict[start_1-1][1] <= 0.5:
							if tmx_dict.has_key(int(helix[2])-1):
								tmx_dict[int(helix[2])-1].append('OrangeRed')
								start_1 = start_1 + 1
							else:
								tmx_dict[int(helix[2])-1] = ['OrangeRed']
								start_1 = start_1 + 1
						elif e_dict[start_1-1][1] <= 0.0:
							if tmx_dict.has_key(int(helix[2])-1):
								tmx_dict[int(helix[2])-1].append('Orange')
								start_1 = start_1 + 1
							else:
								tmx_dict[int(helix[2])-1] = ['Orange']
								start_1 = start_1 + 1
						elif e_dict[start_1-1][1] > 0.5:
							if tmx_dict.has_key(int(helix[2])-1):
								tmx_dict[int(helix[2])-1].append('Red')
								start_1 = start_1 + 1
							else:
								tmx_dict[int(helix[2])-1] = ['Red>']
								start_1 = start_1 + 1
					elif e_dict[start_1-1][0] == 'E':
						if e_dict[start_1-1][1] > 0.0 and e_dict[start_1-1][1] <= 0.5:
							if tmx_dict.has_key(int(helix[2])-1):
								tmx_dict[int(helix[2])-1].append('SlateBlue')
								start_1 = start_1 + 1
							else:
								tmx_dict[int(helix[2])-1] = ['SlateBlue']
								start_1 = start_1 + 1
						elif e_dict[start_1-1][1] <= 0.0:
							if tmx_dict.has_key(int(helix[2])-1):
								tmx_dict[int(helix[2])-1].append('Cyan')
								start_1 = start_1 + 1
							else:
								tmx_dict[int(helix[2])-1] = ['Cyan']
								start_1 = start_1 + 1
						elif e_dict[start_1-1][1] > 0.5:
							if tmx_dict.has_key(int(helix[2])-1):
								tmx_dict[int(helix[2])-1].append('NewMidnightBlue')
								start_1 = start_1 + 1
							else:
								tmx_dict[int(helix[2])-1] = ['NewMidnightBlue']
								start_1 = start_1 + 1
					if c_dict[consstart_1-1][0] < -0.3 :
						if conscol_dict.has_key(int(helix[2])-1):
							conscol_dict[int(helix[2])-1].append('SlateBlue')
							consstart_1 = consstart_1 + 1
						else:
							conscol_dict[int(helix[2])-1] = ['SlateBlue']
							consstart_1 = consstart_1 + 1
					elif c_dict[consstart_1-1][0] >= -0.3 and c_dict[consstart_1-1][0] < 0.0:
						if conscol_dict.has_key(int(helix[2])-1):
							conscol_dict[int(helix[2])-1].append('Cyan')
							consstart_1 = consstart_1 + 1
						else:
							conscol_dict[int(helix[2])-1] = ['Cyan']
							consstart_1 = consstart_1 + 1
					elif c_dict[consstart_1-1][0] >= 0.0 and c_dict[consstart_1-1][0] < 0.3 :
						if conscol_dict.has_key(int(helix[2])-1):
							conscol_dict[int(helix[2])-1].append('Quartz')
							consstart_1 = consstart_1 + 1
						else:
							conscol_dict[int(helix[2])-1] = ['Quartz']
							consstart_1 = consstart_1 + 1
					elif c_dict[consstart_1-1][0] >= 0.3 and c_dict[consstart_1-1][0] < 0.8 :
						if conscol_dict.has_key(int(helix[2])-1):
							conscol_dict[int(helix[2])-1].append('NeonPink')
							consstart_1 = consstart_1 + 1
						else:
							conscol_dict[int(helix[2])-1] = ['NeonPink']
							consstart_1 = consstart_1 + 1
					elif c_dict[consstart_1-1][0] >= 0.8 :
						if conscol_dict.has_key(int(helix[2])-1):
							conscol_dict[int(helix[2])-1].append('DarkPurple')
							consstart_1 = consstart_1 + 1
						else:
							conscol_dict[int(helix[2])-1] = ['DarkPurple']
							consstart_1 = consstart_1 + 1
				else:
					if tmx_dict.has_key(int(helix[2])-1):
						tmx_dict[int(helix[2])-1].append('Green')
						start_1 = start_1 + 1
					else:
						tmx_dict[int(helix[2])-1] = ['Green']
						start_1 = start_1 + 1
					if conscol_dict.has_key(int(helix[2])-1):
						conscol_dict[int(helix[2])-1].append('Green')
						consstart_1 = consstart_1 + 1
					else:
						conscol_dict[int(helix[2])-1] = ['Green']
						consstart_1 = consstart_1 + 1
			
			
			for r2 in helixseq2:
				if seq_dict.has_key(int(helix[2])):
					seq_dict[int(helix[2])].append(str(start2)+r2)
					start2  = start2 + 1
				else:
					seq_dict[int(helix[2])] = [str(start2)+r2]
					start2  = start2 + 1
				if r2 == e_dict[start_2-1][2]:
					if e_dict[start_2-1][0] == 'B':
						if e_dict[start_2-1][1] > 0.0 and e_dict[start_2-1][1] <= 0.5:
							if tmx_dict.has_key(int(helix[2])):
								tmx_dict[int(helix[2])].append('OrangeRed')
								start_2 = start_2 + 1
							else:
								tmx_dict[int(helix[2])] = ['OrangeRed']
								start_2 = start_2 + 1
						elif e_dict[start_2-1][1] <= 0.0:
							if tmx_dict.has_key(int(helix[2])):
								tmx_dict[int(helix[2])].append('Orange')
								start_2 = start_2 + 1
							else:
								tmx_dict[int(helix[2])] = ['Orange']
								start_2 = start_2 + 1
						elif e_dict[start_2-1][1] > 0.5:
							if tmx_dict.has_key(int(helix[2])):
								tmx_dict[int(helix[2])].append('Red')
								start_2 = start_2 + 1
							else:
								tmx_dict[int(helix[2])] = ['Red>']
								start_2 = start_2 + 1
					elif e_dict[start_2-1][0] == 'E':
						if e_dict[start_2-1][1] > 0.0 and e_dict[start_2-1][1] <= 0.5:
							if tmx_dict.has_key(int(helix[2])):
								tmx_dict[int(helix[2])].append('SlateBlue')
								start_2 = start_2 + 1
							else:
								tmx_dict[int(helix[2])] = ['SlateBlue']
								start_2 = start_2 + 1
						elif e_dict[start_2-1][1] <= 0.0:
							if tmx_dict.has_key(int(helix[2])):
								tmx_dict[int(helix[2])].append('Cyan')
								start_2 = start_2 + 1
							else:
								tmx_dict[int(helix[2])] = ['Cyan']
								start_2 = start_2 + 1
						elif e_dict[start_2-1][1] > 0.5:
							if tmx_dict.has_key(int(helix[2])):
								tmx_dict[int(helix[2])].append('NewMidnightBlue')
								start_2 = start_2 + 1
							else:
								tmx_dict[int(helix[2])] = ['NewMidnightBlue']
								start_2 = start_2 + 1
					if c_dict[consstart_2][0] < -0.3 :
						if conscol_dict.has_key(int(helix[2])):
							conscol_dict[int(helix[2])].append('SlateBlue')
							consstart_2 = consstart_2 + 1
						else:
							conscol_dict[int(helix[2])] = ['SlateBlue']
							consstart_2 = consstart_2 + 1
					elif c_dict[consstart_2-1][0] >= -0.3 and c_dict[consstart_2-1][0] < 0.0:
						if conscol_dict.has_key(int(helix[2])):
							conscol_dict[int(helix[2])].append('Cyan')
							consstart_2 = consstart_2 + 1
						else:
							conscol_dict[int(helix[2])] = ['Cyan']
							consstart_2 = consstart_2 + 1
					elif c_dict[consstart_2-1][0] >= 0.0 and c_dict[consstart_2-1][0] < 0.3 :
						if conscol_dict.has_key(int(helix[2])):
							conscol_dict[int(helix[2])].append('Quartz')
							consstart_2 = consstart_2 + 1
						else:
							conscol_dict[int(helix[2])] = ['Quartz']
							consstart_2 = consstart_2 + 1
					elif c_dict[consstart_2-1][0] >= 0.3 and c_dict[consstart_2-1][0] < 0.8 :
						if conscol_dict.has_key(int(helix[2])):
							conscol_dict[int(helix[2])].append('NeonPink')
							consstart_2 = consstart_2 + 1
						else:
							conscol_dict[int(helix[2])] = ['NeonPink']
							consstart_2 = consstart_2 + 1
					elif c_dict[consstart_2-1][0] >= 0.8 :
						if conscol_dict.has_key(int(helix[2])):
							conscol_dict[int(helix[2])].append('DarkPurple')
							consstart_2 = consstart_2 + 1
						else:
							conscol_dict[int(helix[2])] = ['DarkPurple']
							consstart_2 = consstart_2 + 1
				else:
					if tmx_dict.has_key(int(helix[2])):
						tmx_dict[int(helix[2])].append('Green')
						start_2 = start_2 + 1
					else:
						tmx_dict[int(helix[2])] = ['Green']
						start_2 = start_2 + 1
					if conscol_dict.has_key(int(helix[2])):
						conscol_dict[int(helix[2])].append('Green')
						consstart_2 = consstart_2 + 1
					else:
						conscol_dict[int(helix[2])] = ['Green']
						consstart_2 = consstart_2 + 1
	
	return (seq_dict,tmx_dict,conscol_dict)
	

def writeimage(hd,sl,vol,coords,ld,fll,rld,lcoords,bgcolor,fcolor,name): # write a pov image

	cwd = getcwd()
	if cwd.endswith('/images'):
		mainpath = abspath('..')
	else:
		mainpath = cwd
	
	
	image = file(name,'w')
	
	if vol < 80:
		vol = 80
	else:
		pass
	
	#header of each pov file
	image.write('#version 3.6;\n')
	image.write('global_settings { assumed_gamma 1.3 }\n\n\n')
	image.write('#include "colors.inc"\n')
	image.write('#include "textures.inc"\n')
	image.write('#include "'+mainpath+'/topo1.inc"\n')
	image.write('//----------------------------------------------------------------------\n')
	image.write('// camera --------------------------------------------------------------\n\n')
	image.write('camera {\n')
	image.write('\tperspective\n')
	image.write('\tlocation <'+str((vol)/2)+', 0, -'+str(vol-5)+'>\n')
	image.write('\tlook_at <'+str((vol)/2)+', 0, 10>\n')
	image.write('\tdirection <0,0,1>\n')
	image.write('\tright <1,0,0>\n')
	image.write('}\n\n')
	image.write('light_source {\n')
	image.write('\t<'+str((vol)/2)+', 20, -50>\n')
	image.write('\tcolor rgb 1.0 shadowless\n')
	image.write('}\n\n')
	image.write('light_source {\n')
	image.write('\t<'+str((vol)/2)+',10, -20>\n')
	image.write('\tcolor rgb 1.0\n')
	image.write('\tparallel\n')
	image.write('\tpoint_at <'+str((vol)/2)+', 0, 40>\n')
	image.write('}\n\n')
	image.write('sky_sphere {pigment {'+bgcolor+'}}\n\n')	
	image.write('//----------------------------------------------------------------------\n')
	image.write('// topology --------------------------------------------------------------\n\n')

	image.write('object{membrane('+str(vol)+','+fcolor+')}\n')
	
	#placing the helices##############################################################
	

	for helix in coords:
		if helix[1] == 'tm':
			image.write('object{helixlabel("'+helix[2]+'",'+fcolor+','+str(coords[helix][0]-7)+',0)}\n')
			if helix[3] == 'p':
				image.write('object{alphaHelixperi('+str(hd[helix][2])+',Red,'+fcolor+') translate<'+str(coords[helix][0])+','+str(coords[helix][1])+','+str(coords[helix][2])+'>}\n')
				image.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1])+')}\n')
				image.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1]+hd[helix][4])+')}\n')
			elif  helix[3] == 'c':
				image.write('object{alphaHelixcyto('+str(hd[helix][2])+',Red,'+fcolor+') translate<'+str(coords[helix][0])+','+str(coords[helix][1])+','+str(coords[helix][2])+'>}\n')
				image.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1])+')}\n')
				image.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1]-hd[helix][4])+')}\n')
		elif helix[1] == 'stm':
			if helix[3] == 'p':
				image.write('object{helixlabel("'+helix[2]+'",'+fcolor+','+str(coords[helix][0]-7)+','+str(float((coords[helix][1]+hd[helix][4]-float(hd[helix][5]*5.4)/2)))+')}\n')#10
				image.write('object{helixlabel("'+str(int(helix[2])-1)+'",'+fcolor+','+str(coords[helix][0]-7)+','+str(float((coords[helix][1]+float((hd[helix][3]*5.4)/2))))+')}\n')#-10
				image.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1])+')}\n')
				image.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1]+hd[helix][4])+')}\n')
				image.write('object{helixlabel1("'+str(hd[helix][7])+'",'+fcolor+','+str(coords[helix][0]-5)+','+str(coords[helix][1]+hd[helix][4]-float(hd[helix][5]*5.4)-1)+')}\n')
				image.write('object{helixlabel1("'+str(hd[helix][6])+'",'+fcolor+','+str(coords[helix][0]-5)+','+str(coords[helix][1]+float(hd[helix][3]*5.4)+1.5)+')}\n')
				image.write('object{shwithloopperi('+str(coords[helix][0])+','+str(coords[helix][1])+','+str(coords[helix][2])+','+str(hd[helix][6]-hd[helix][0]+1)+','+str((hd[helix][7]-hd[helix][6])-1)+','+str(hd[helix][1]-hd[helix][7]+1)+',Red,'+fcolor+')}\n')
			elif  helix[3] == 'c':
				image.write('object{helixlabel("'+helix[2]+'",'+fcolor+','+str(coords[helix][0]-7)+','+str(float((coords[helix][1]-hd[helix][4]+float(hd[helix][5]*5.4)/2)))+')}\n')#-10
				image.write('object{helixlabel("'+str(int(helix[2])-1)+'",'+fcolor+','+str(coords[helix][0]-7)+','+str(float((coords[helix][1]-float((hd[helix][3]*5.4)/2))))+')}\n')#10
				image.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1])+')}\n')
				image.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1]-hd[helix][4])+')}\n')
				image.write('object{helixlabel1("'+str(hd[helix][7])+'",'+fcolor+','+str(coords[helix][0]-5)+','+str(coords[helix][1]-(hd[helix][4]-float(hd[helix][5]*5.4))+1)+')}\n')
				image.write('object{helixlabel1("'+str(hd[helix][6])+'",'+fcolor+','+str(coords[helix][0]-5)+','+str(coords[helix][1]-float(hd[helix][3]*5.4)-1.5)+')}\n')
				image.write('object{shwithloopcyto('+str(coords[helix][0])+','+str(coords[helix][1])+','+str(coords[helix][2])+','+str(hd[helix][6]-hd[helix][0]+1)+','+str((hd[helix][7]-hd[helix][6])-1)+','+str(hd[helix][1]-hd[helix][7]+1)+',Red,'+fcolor+')}\n')
		elif helix[1] == 'ih':
			if coords[helix][1] > 0:
				image.write('object{helixlabel("'+helix[2]+'",'+fcolor+','+str(coords[helix][0]+5)+',11)}\n')
				image.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0])+',11)}\n')
				image.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]+hd[helix][4])+',11)}\n')
			else:
				image.write('object{helixlabel("'+helix[2]+'",'+fcolor+','+str(coords[helix][0]+5)+',-13)}\n')
				image.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0])+',-13)}\n')
				image.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]+hd[helix][4])+',-13)}\n')
			image.write('object{alphaHelixinterface('+str(hd[helix][2])+',Red,'+fcolor+') translate<'+str(coords[helix][0])+','+str(coords[helix][1])+','+str(coords[helix][2])+'>}\n')

	
	#placing the loops##############################################################	
	
	for loops in fll:
		if fll[loops][1] > 0:
			image.write('object{startendloopcyto('+str(fll[loops][0])+','+str(fll[loops][1])+','+str(fll[loops][2])+','+str(ld[loops]-1)+',Red)}\n')
		else:
			image.write('object{startendloopperi('+str(fll[loops][0])+','+str(fll[loops][1])+','+str(fll[loops][2])+','+str(ld[loops]-1)+',Red)}\n')
	
	for rl in rld:
		if rld[rl][1] > 0:
			image.write('object{reentantloopcyto('+str(rld[rl][0])+','+str(rld[rl][1])+','+str(rld[rl][2])+','+str(rld[rl][3])+','+str(rld[rl][4])+','+str(rld[rl][5])+','+str(rld[rl][6])+','+str(rld[rl][7])+','+str(rld[rl][8])+',Red)}\n')
		else:
			image.write('object{reentantloopperi('+str(rld[rl][0])+','+str(rld[rl][1])+','+str(rld[rl][2])+','+str(rld[rl][3])+','+str(rld[rl][4])+','+str(rld[rl][5])+','+str(rld[rl][6])+','+str(rld[rl][7])+','+str(rld[rl][8])+',Red)}\n')

	for l in lcoords:
		if lcoords[l][6] == 0 and lcoords[l][7] == 0:
			if lcoords[l][1] > 0:
				image.write('object{loopcurve('+str(lcoords[l][9])+','+str(lcoords[l][10])+','+str(lcoords[l][11])+',Red) translate<'+str(lcoords[l][0]+((lcoords[l][3]-lcoords[l][0])/2))+','+str((lcoords[l][1]+lcoords[l][4])/2 )+','+str(lcoords[l][2])+'>}\n')
			else:
				image.write('object{loopcurve2('+str(lcoords[l][9])+','+str(lcoords[l][10])+','+str(lcoords[l][11])+',Red) translate<'+str(lcoords[l][0]+((lcoords[l][3]-lcoords[l][0])/2))+','+str((lcoords[l][1]+lcoords[l][4])/2 )+','+str(lcoords[l][2])+'>}\n')
		else:
			if lcoords[l][1] > 0:
				image.write('object{cytoloop('+str(lcoords[l][0])+','+str(lcoords[l][1])+','+str(lcoords[l][2])+','+str(lcoords[l][3])+','+str(lcoords[l][4])+','+str(lcoords[l][5])+','+str(lcoords[l][6])+','+str(lcoords[l][7])+','+str(lcoords[l][8])+','+str(lcoords[l][9])+','+str(lcoords[l][10])+','+str(lcoords[l][11])+',Red)}\n')
			else:
				image.write('object{periloop('+str(lcoords[l][0])+','+str(lcoords[l][1])+','+str(lcoords[l][2])+','+str(lcoords[l][3])+','+str(lcoords[l][4])+','+str(lcoords[l][5])+','+str(lcoords[l][6])+','+str(lcoords[l][7])+','+str(lcoords[l][8])+','+str(lcoords[l][9])+','+str(lcoords[l][10])+','+str(lcoords[l][11])+',Red)}\n')
	
	image.close()





def modify_povfile(povfile,ncc,ncl,hd,coords,oname,fcolor,rld,fll,lcoords,ld,nc): # write non contacts in a new pov file
	
	# header of the pov file stays the same
	nchelices = ncc.keys()
	ncloops = ncl.keys()
	
	pf = file(povfile, 'r')
	line_lst = pf.readlines()
	pf.close()
	
	ncimage = file(oname,'w')

	for line in line_lst:
		if line.startswith('object{membrane'):
			ncimage.write(line)
		elif line.startswith('object'):
			pass
		else:
			ncimage.write(line)
	
	if len(nchelices) > 0: # new coordinates for helices if they are shifted and new color
		
		### writing helices ###########################
		
		for helix in coords:
			if helix in nchelices:
				ncimage.write('object{helixlabel("'+helix[2]+'",'+fcolor+','+str(ncc[helix][0]-7)+',0)}\n')
				if int(helix[2]) in nc:
					if helix[3] == 'p':
						ncimage.write('object{alphaHelixperi('+str(hd[helix][2])+',Green,'+fcolor+') translate<'+str(ncc[helix][0])+','+str(ncc[helix][1])+','+str(ncc[helix][2])+'>}\n')
						ncimage.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(ncc[helix][0]-3)+','+str(ncc[helix][1])+')}\n')
						ncimage.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(ncc[helix][0]-3)+','+str(ncc[helix][1]+hd[helix][4])+')}\n')
					elif  helix[3] == 'c':
						ncimage.write('object{alphaHelixcyto('+str(hd[helix][2])+',Green,'+fcolor+') translate<'+str(ncc[helix][0])+','+str(ncc[helix][1])+','+str(ncc[helix][2])+'>}\n')
						ncimage.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(ncc[helix][0]-3)+','+str(ncc[helix][1])+')}\n')
						ncimage.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(ncc[helix][0]-3)+','+str(ncc[helix][1]-hd[helix][4])+')}\n')
				else:
					if helix[3] == 'p':
						ncimage.write('object{alphaHelixperi('+str(hd[helix][2])+',Red,'+fcolor+') translate<'+str(ncc[helix][0])+','+str(ncc[helix][1])+','+str(ncc[helix][2])+'>}\n')
						ncimage.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(ncc[helix][0]-3)+','+str(ncc[helix][1])+')}\n')
						ncimage.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(ncc[helix][0]-3)+','+str(ncc[helix][1]+hd[helix][4])+')}\n')
					elif  helix[3] == 'c':
						ncimage.write('object{alphaHelixcyto('+str(hd[helix][2])+',Red,'+fcolor+') translate<'+str(ncc[helix][0])+','+str(ncc[helix][1])+','+str(ncc[helix][2])+'>}\n')
						ncimage.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(ncc[helix][0]-3)+','+str(ncc[helix][1])+')}\n')
						ncimage.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(ncc[helix][0]-3)+','+str(ncc[helix][1]-hd[helix][4])+')}\n')
			else:
				if helix[1] == 'tm':
					ncimage.write('object{helixlabel("'+helix[2]+'",'+fcolor+','+str(coords[helix][0]-7)+',0)}\n')
					if int(helix[2]) in nc:
						if helix[3] == 'p':
							ncimage.write('object{alphaHelixperi('+str(hd[helix][2])+',Green,'+fcolor+') translate<'+str(coords[helix][0])+','+str(coords[helix][1])+','+str(coords[helix][2])+'>}\n')
							ncimage.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1])+')}\n')
							ncimage.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1]+hd[helix][4])+')}\n')
						elif  helix[3] == 'c':
							ncimage.write('object{alphaHelixcyto('+str(hd[helix][2])+',Green,'+fcolor+') translate<'+str(coords[helix][0])+','+str(coords[helix][1])+','+str(coords[helix][2])+'>}\n')
							ncimage.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1])+')}\n')
							ncimage.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1]-hd[helix][4])+')}\n')
					else:
						if helix[3] == 'p':
							ncimage.write('object{alphaHelixperi('+str(hd[helix][2])+',Red,'+fcolor+') translate<'+str(coords[helix][0])+','+str(coords[helix][1])+','+str(coords[helix][2])+'>}\n')
							ncimage.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1])+')}\n')
							ncimage.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1]+hd[helix][4])+')}\n')
						elif  helix[3] == 'c':
							ncimage.write('object{alphaHelixcyto('+str(hd[helix][2])+',Red,'+fcolor+') translate<'+str(coords[helix][0])+','+str(coords[helix][1])+','+str(coords[helix][2])+'>}\n')
							ncimage.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1])+')}\n')
							ncimage.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1]-hd[helix][4])+')}\n')
				elif helix[1] == 'stm':
					if helix[3] == 'p':
						ncimage.write('object{helixlabel("'+helix[2]+'",'+fcolor+','+str(coords[helix][0]-7)+','+str(float((coords[helix][1]+hd[helix][4]-float(hd[helix][5]*5.4)/2)))+')}\n')#10
						ncimage.write('object{helixlabel("'+str(int(helix[2])-1)+'",'+fcolor+','+str(coords[helix][0]-7)+','+str(float((coords[helix][1]+float((hd[helix][3]*5.4)/2))))+')}\n')#-10
						ncimage.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1])+')}\n')
						ncimage.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1]+hd[helix][4])+')}\n')
						ncimage.write('object{helixlabel1("'+str(hd[helix][7])+'",'+fcolor+','+str(coords[helix][0]-5)+','+str(coords[helix][1]+hd[helix][4]-float(hd[helix][5]*5.4)-1)+')}\n')
						ncimage.write('object{helixlabel1("'+str(hd[helix][6])+'",'+fcolor+','+str(coords[helix][0]-5)+','+str(coords[helix][1]+float(hd[helix][3]*5.4)+1.5)+')}\n')
						ncimage.write('object{shwithloopperi('+str(coords[helix][0])+','+str(coords[helix][1])+','+str(coords[helix][2])+','+str(hd[helix][6]-hd[helix][0]+1)+','+str((hd[helix][7]-hd[helix][6])-1)+','+str(hd[helix][1]-hd[helix][7]+1)+',Red,'+fcolor+')}\n')
					elif  helix[3] == 'c':
						ncimage.write('object{helixlabel("'+helix[2]+'",'+fcolor+','+str(coords[helix][0]-7)+','+str(float((coords[helix][1]-hd[helix][4]+float(hd[helix][5]*5.4)/2)))+')}\n')#-10
						ncimage.write('object{helixlabel("'+str(int(helix[2])-1)+'",'+fcolor+','+str(coords[helix][0]-7)+','+str(float((coords[helix][1]-float((hd[helix][3]*5.4)/2))))+')}\n')#10
						ncimage.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1])+')}\n')
						ncimage.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1]-hd[helix][4])+')}\n')
						ncimage.write('object{helixlabel1("'+str(hd[helix][7])+'",'+fcolor+','+str(coords[helix][0]-5)+','+str(coords[helix][1]-(hd[helix][4]-float(hd[helix][5]*5.4))+1)+')}\n')
						ncimage.write('object{helixlabel1("'+str(hd[helix][6])+'",'+fcolor+','+str(coords[helix][0]-5)+','+str(coords[helix][1]-float(hd[helix][3]*5.4)-1.5)+')}\n')
						ncimage.write('object{shwithloopcyto('+str(coords[helix][0])+','+str(coords[helix][1])+','+str(coords[helix][2])+','+str(hd[helix][6]-hd[helix][0]+1)+','+str((hd[helix][7]-hd[helix][6])-1)+','+str(hd[helix][1]-hd[helix][7]+1)+',Red,'+fcolor+')}\n')
				elif helix[1] == 'ih':
					ncimage.write('object{alphaHelixinterface('+str(hd[helix][2])+',Red,'+fcolor+') translate<'+str(coords[helix][0])+','+str(coords[helix][1])+','+str(coords[helix][2])+'>}\n')
					if coords[helix][1] > 0:
						ncimage.write('object{helixlabel("'+helix[2]+'",'+fcolor+','+str(coords[helix][0]+5)+',11)}\n')
						ncimage.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0])+',11)}\n')
						ncimage.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]+hd[helix][4])+',11)}\n')
					else:
						ncimage.write('object{helixlabel("'+helix[2]+'",'+fcolor+','+str(coords[helix][0]+5)+',-13)}\n')
						ncimage.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0])+',-13)}\n')
						ncimage.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]+hd[helix][4])+',-13)}\n')
		
		### writing loops ###########################

		for loops in fll:
			if loops in ncloops:
				if ncl[loops][1] > 0:
					ncimage.write('object{startendloopcyto('+str(ncl[loops][0])+','+str(ncl[loops][1])+','+str(ncl[loops][2])+','+str(ld[loops]-1)+',Red)}\n')
				else:
					ncimage.write('object{startendloopperi('+str(ncl[loops][0])+','+str(ncl[loops][1])+','+str(ncl[loops][2])+','+str(ld[loops]-1)+',Red)}\n')
			else:
				if fll[loops][1] > 0:
					ncimage.write('object{startendloopcyto('+str(fll[loops][0])+','+str(fll[loops][1])+','+str(fll[loops][2])+','+str(ld[loops]-1)+',Red)}\n')
				else:
					ncimage.write('object{startendloopperi('+str(fll[loops][0])+','+str(fll[loops][1])+','+str(fll[loops][2])+','+str(ld[loops]-1)+',Red)}\n')
	
		for rl in rld:
			if rld[rl][1] > 0:
				ncimage.write('object{reentantloopcyto('+str(rld[rl][0])+','+str(rld[rl][1])+','+str(rld[rl][2])+','+str(rld[rl][3])+','+str(rld[rl][4])+','+str(rld[rl][5])+','+str(rld[rl][6])+','+str(rld[rl][7])+','+str(rld[rl][8])+',Red)}\n')
			else:
				ncimage.write('object{reentantloopperi('+str(rld[rl][0])+','+str(rld[rl][1])+','+str(rld[rl][2])+','+str(rld[rl][3])+','+str(rld[rl][4])+','+str(rld[rl][5])+','+str(rld[rl][6])+','+str(rld[rl][7])+','+str(rld[rl][8])+',Red)}\n')
	
		for l in lcoords:
			if l in ncloops:
				if ncl[l][1] > 0:
					ncimage.write('object{cytoloop('+str(ncl[l][0])+','+str(ncl[l][1])+','+str(ncl[l][2])+','+str(ncl[l][3])+','+str(ncl[l][4])+','+str(ncl[l][5])+','+str(ncl[l][6])+','+str(ncl[l][7])+','+str(ncl[l][8])+','+str(ncl[l][9])+','+str(ncl[l][10])+','+str(ncl[l][11])+',Red)}\n')
				else:
					ncimage.write('object{periloop('+str(ncl[l][0])+','+str(ncl[l][1])+','+str(ncl[l][2])+','+str(ncl[l][3])+','+str(ncl[l][4])+','+str(ncl[l][5])+','+str(ncl[l][6])+','+str(ncl[l][7])+','+str(ncl[l][8])+','+str(ncl[l][9])+','+str(ncl[l][10])+','+str(ncl[l][11])+',Red)}\n')
			else:
				if lcoords[l][6] == 0 and lcoords[l][7] == 0:
					if lcoords[l][1] > 0:
						ncimage.write('object{loopcurve('+str(lcoords[l][9])+','+str(lcoords[l][10])+','+str(lcoords[l][11])+',Red) translate<'+str(lcoords[l][0]+((lcoords[l][3]-lcoords[l][0])/2))+','+str((lcoords[l][1]+lcoords[l][4])/2 )+','+str(lcoords[l][2])+'>}\n')
					else:
						ncimage.write('object{loopcurve2('+str(lcoords[l][9])+','+str(lcoords[l][10])+','+str(lcoords[l][11])+',Red) translate<'+str(lcoords[l][0]+((lcoords[l][3]-lcoords[l][0])/2))+','+str((lcoords[l][1]+lcoords[l][4])/2 )+','+str(lcoords[l][2])+'>}\n')
				else:
					if lcoords[l][1] > 0:
						ncimage.write('object{cytoloop('+str(lcoords[l][0])+','+str(lcoords[l][1])+','+str(lcoords[l][2])+','+str(lcoords[l][3])+','+str(lcoords[l][4])+','+str(lcoords[l][5])+','+str(lcoords[l][6])+','+str(lcoords[l][7])+','+str(lcoords[l][8])+','+str(lcoords[l][9])+','+str(lcoords[l][10])+','+str(lcoords[l][11])+',Red)}\n')
					else:
						ncimage.write('object{periloop('+str(lcoords[l][0])+','+str(lcoords[l][1])+','+str(lcoords[l][2])+','+str(lcoords[l][3])+','+str(lcoords[l][4])+','+str(lcoords[l][5])+','+str(lcoords[l][6])+','+str(lcoords[l][7])+','+str(lcoords[l][8])+','+str(lcoords[l][9])+','+str(lcoords[l][10])+','+str(lcoords[l][11])+',Red)}\n')
	
	elif len(nc) > 0: # new color for non contacts if they were not shifted
		for helix in coords:
			if helix[1] == 'tm':
					ncimage.write('object{helixlabel("'+helix[2]+'",'+fcolor+','+str(coords[helix][0]-7)+',0)}\n')
					if int(helix[2]) in nc:
						if helix[3] == 'p':
							ncimage.write('object{alphaHelixperi('+str(hd[helix][2])+',Green,'+fcolor+') translate<'+str(coords[helix][0])+','+str(coords[helix][1])+','+str(coords[helix][2])+'>}\n')
							ncimage.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1])+')}\n')
							ncimage.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1]+hd[helix][4])+')}\n')
						elif  helix[3] == 'c':
							ncimage.write('object{alphaHelixcyto('+str(hd[helix][2])+',Green,'+fcolor+') translate<'+str(coords[helix][0])+','+str(coords[helix][1])+','+str(coords[helix][2])+'>}\n')
							ncimage.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1])+')}\n')
							ncimage.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1]-hd[helix][4])+')}\n')
					else:
						if helix[3] == 'p':
							ncimage.write('object{alphaHelixperi('+str(hd[helix][2])+',Red,'+fcolor+') translate<'+str(coords[helix][0])+','+str(coords[helix][1])+','+str(coords[helix][2])+'>}\n')
							ncimage.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1])+')}\n')
							ncimage.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1]+hd[helix][4])+')}\n')
						elif  helix[3] == 'c':
							ncimage.write('object{alphaHelixcyto('+str(hd[helix][2])+',Red,'+fcolor+') translate<'+str(coords[helix][0])+','+str(coords[helix][1])+','+str(coords[helix][2])+'>}\n')
							ncimage.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1])+')}\n')
							ncimage.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1]-hd[helix][4])+')}\n')
			elif helix[1] == 'stm':
				if helix[3] == 'p':
					ncimage.write('object{helixlabel("'+helix[2]+'",'+fcolor+','+str(coords[helix][0]-7)+','+str(float((coords[helix][1]+hd[helix][4]-float(hd[helix][5]*5.4)/2)))+')}\n')#10
					ncimage.write('object{helixlabel("'+str(int(helix[2])-1)+'",'+fcolor+','+str(coords[helix][0]-7)+','+str(float((coords[helix][1]+float((hd[helix][3]*5.4)/2))))+')}\n')#-10
					ncimage.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1])+')}\n')
					ncimage.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1]+hd[helix][4])+')}\n')
					ncimage.write('object{helixlabel1("'+str(hd[helix][7])+'",'+fcolor+','+str(coords[helix][0]-5)+','+str(coords[helix][1]+hd[helix][4]-float(hd[helix][5]*5.4)-1)+')}\n')
					ncimage.write('object{helixlabel1("'+str(hd[helix][6])+'",'+fcolor+','+str(coords[helix][0]-5)+','+str(coords[helix][1]+float(hd[helix][3]*5.4)+1.5)+')}\n')
					ncimage.write('object{shwithloopperi('+str(coords[helix][0])+','+str(coords[helix][1])+','+str(coords[helix][2])+','+str(hd[helix][6]-hd[helix][0]+1)+','+str((hd[helix][7]-hd[helix][6])-1)+','+str(hd[helix][1]-hd[helix][7]+1)+',Red,'+fcolor+')}\n')
				elif  helix[3] == 'c':
					ncimage.write('object{helixlabel("'+helix[2]+'",'+fcolor+','+str(coords[helix][0]-7)+','+str(float((coords[helix][1]-hd[helix][4]+float(hd[helix][5]*5.4)/2)))+')}\n')#-10
					ncimage.write('object{helixlabel("'+str(int(helix[2])-1)+'",'+fcolor+','+str(coords[helix][0]-7)+','+str(float((coords[helix][1]-float((hd[helix][3]*5.4)/2))))+')}\n')#10
					ncimage.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1])+')}\n')
					ncimage.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]-3)+','+str(coords[helix][1]-hd[helix][4])+')}\n')
					ncimage.write('object{helixlabel1("'+str(hd[helix][7])+'",'+fcolor+','+str(coords[helix][0]-5)+','+str(coords[helix][1]-(hd[helix][4]-float(hd[helix][5]*5.4))+1)+')}\n')
					ncimage.write('object{helixlabel1("'+str(hd[helix][6])+'",'+fcolor+','+str(coords[helix][0]-5)+','+str(coords[helix][1]-float(hd[helix][3]*5.4)-1.5)+')}\n')
					ncimage.write('object{shwithloopcyto('+str(coords[helix][0])+','+str(coords[helix][1])+','+str(coords[helix][2])+','+str(hd[helix][6]-hd[helix][0]+1)+','+str((hd[helix][7]-hd[helix][6])-1)+','+str(hd[helix][1]-hd[helix][7]+1)+',Red,'+fcolor+')}\n')
			elif helix[1] == 'ih':
				ncimage.write('object{alphaHelixinterface('+str(hd[helix][2])+',Red,'+fcolor+') translate<'+str(coords[helix][0])+','+str(coords[helix][1])+','+str(coords[helix][2])+'>}\n')
				if coords[helix][1] > 0:
					ncimage.write('object{helixlabel("'+helix[2]+'",'+fcolor+','+str(coords[helix][0]+5)+',11)}\n')
					ncimage.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0])+',11)}\n')
					ncimage.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]+hd[helix][4])+',11)}\n')
				else:
					ncimage.write('object{helixlabel("'+helix[2]+'",'+fcolor+','+str(coords[helix][0]+5)+',-13)}\n')
					ncimage.write('object{helixlabel1("'+str(hd[helix][0])+'",'+fcolor+','+str(coords[helix][0])+',-13)}\n')
					ncimage.write('object{helixlabel1("'+str(hd[helix][1])+'",'+fcolor+','+str(coords[helix][0]+hd[helix][4])+',-13)}\n')
					
		for loops in fll:
			if fll[loops][1] > 0:
				ncimage.write('object{startendloopcyto('+str(fll[loops][0])+','+str(fll[loops][1])+','+str(fll[loops][2])+','+str(ld[loops]-1)+',Red)}\n')
			else:
				ncimage.write('object{startendloopperi('+str(fll[loops][0])+','+str(fll[loops][1])+','+str(fll[loops][2])+','+str(ld[loops]-1)+',Red)}\n')
		
		for rl in rld:
			if rld[rl][1] > 0:
				ncimage.write('object{reentantloopcyto('+str(rld[rl][0])+','+str(rld[rl][1])+','+str(rld[rl][2])+','+str(rld[rl][3])+','+str(rld[rl][4])+','+str(rld[rl][5])+','+str(rld[rl][6])+','+str(rld[rl][7])+','+str(rld[rl][8])+',Red)}\n')
			else:
				ncimage.write('object{reentantloopperi('+str(rld[rl][0])+','+str(rld[rl][1])+','+str(rld[rl][2])+','+str(rld[rl][3])+','+str(rld[rl][4])+','+str(rld[rl][5])+','+str(rld[rl][6])+','+str(rld[rl][7])+','+str(rld[rl][8])+',Red)}\n')
	
		for l in lcoords:
			if lcoords[l][6] == 0 and lcoords[l][7] == 0:
				if lcoords[l][1] > 0:
					ncimage.write('object{loopcurve('+str(lcoords[l][9])+','+str(lcoords[l][10])+','+str(lcoords[l][11])+',Red) translate<'+str(lcoords[l][0]+((lcoords[l][3]-lcoords[l][0])/2))+','+str((lcoords[l][1]+lcoords[l][4])/2 )+','+str(lcoords[l][2])+'>}\n')
				else:
					ncimage.write('object{loopcurve2('+str(lcoords[l][9])+','+str(lcoords[l][10])+','+str(lcoords[l][11])+',Red) translate<'+str(lcoords[l][0]+((lcoords[l][3]-lcoords[l][0])/2))+','+str((lcoords[l][1]+lcoords[l][4])/2 )+','+str(lcoords[l][2])+'>}\n')
			else:
				if lcoords[l][1] > 0:
					ncimage.write('object{cytoloop('+str(lcoords[l][0])+','+str(lcoords[l][1])+','+str(lcoords[l][2])+','+str(lcoords[l][3])+','+str(lcoords[l][4])+','+str(lcoords[l][5])+','+str(lcoords[l][6])+','+str(lcoords[l][7])+','+str(lcoords[l][8])+','+str(lcoords[l][9])+','+str(lcoords[l][10])+','+str(lcoords[l][11])+',Red)}\n')
				else:
					ncimage.write('object{periloop('+str(lcoords[l][0])+','+str(lcoords[l][1])+','+str(lcoords[l][2])+','+str(lcoords[l][3])+','+str(lcoords[l][4])+','+str(lcoords[l][5])+','+str(lcoords[l][6])+','+str(lcoords[l][7])+','+str(lcoords[l][8])+','+str(lcoords[l][9])+','+str(lcoords[l][10])+','+str(lcoords[l][11])+',Red)}\n')
		
		ncimage.close()



def writehelixwheel(name,color_array,res_array,l,bgcolor,fcolor): # writes the pov files for the helical wheels
	
	cwd = getcwd()
	if cwd.endswith('/images'):
		mainpath = abspath('..')
	else:
		mainpath = cwd
	
	wimage = file(name,'w')
	
	#header of each helical wheel pov file
	wimage.write('#version 3.6;\n')
	wimage.write('global_settings { assumed_gamma 1.3 }\n\n\n')
	wimage.write('#include "colors.inc"\n')
	wimage.write('#include "textures.inc"\n')
	wimage.write('#include "'+mainpath+'/topo1.inc"\n')
	wimage.write('//----------------------------------------------------------------------\n')
	wimage.write('// camera --------------------------------------------------------------\n\n')
	wimage.write('camera {\n')
	wimage.write('\tperspective\n')
	wimage.write('\tlocation <1,0,-60>\n')
	wimage.write('\tlook_at <1,0,0>\n')
	wimage.write('\tdirection <0,0,1>\n')
	wimage.write('\tright <1,0,0>\n')
	wimage.write('}\n\n')
	wimage.write('light_source {\n')
	wimage.write('\t<-10, 20, -40>\n')
	wimage.write('\tcolor rgb 1.0 shadowless\n')
	wimage.write('}\n\n')
	wimage.write('light_source {\n')
	wimage.write('\t<10,10,-20>\n')
	wimage.write('\tcolor rgb 1.0\n')
	wimage.write('\tparallel\n')
	wimage.write('\tpoint_at <0,0,10>\n')
	wimage.write('}\n\n')
	wimage.write('sky_sphere {pigment {'+bgcolor+'}}\n\n')	
	wimage.write('//----------------------------------------------------------------------\n\n\n')

	res_str = ''
	for res in res_array:
		res_str = res_str +'"'+res+'",'
	res_str = res_str[:len(res_str)-1]
	
	color_str = ''
	for color in color_array:
		color_str = color_str + color+','
	color_str = color_str[:len(color_str)-1]
	
	
	wimage.write('#declare res_array = array['+str(l)+']{'+res_str+'};\n')
	wimage.write('#declare color_array = array['+str(l)+']{'+color_str+'};\n')

	wimage.write('object{helixwheel(color_array,'+str(l)+',res_array,'+fcolor+') translate<0,0,2>}')
	
	wimage.close()




def exe_povray(pi,name,w): # executes the raytracer 'POVRay'
	
	cwd = getcwd()
	if cwd.endswith('/images'):
		mainpath = abspath('..')
	else:
		mainpath = cwd
		chdir(cwd+'/images')
		
	allfiles = listdir(getcwd())
	if 'DejaVuSans.ttf' in allfiles:
		pass
	else:
		cmd1 = 'cp '+mainpath+'/DejaVuSans.ttf'+' '+getcwd()+'/DejaVuSans.ttf'
		popen(cmd1, 'r')
		
	path = 'povray  '+pi+' +O'+name+' +W'+str(w)+' +H'+str(w)+' +FP -D'
        povray = popen(path, 'r')



def createtopo(filename, povname, hwname): # calculates and creates a topology pov file
	
	file = filename
	data = datainput(file)
	loops = dataevaluation(data[0],data[2],data[1],data[3])
	xcoords = getting_xcoordinate(loops[3],loops[1])
	ycoords = getting_ycoordinate(loops[3],loops[1],loops[0],xcoords[0])
	lcoords = loopcoordinates(ycoords,loops[3],loops[0],loops[1],loops[2])
	if len(loops[4]) > 0:
		newcoords = non_contacts_coords(loops[4],ycoords,lcoords[0],lcoords[1],lcoords[2],loops[0],loops[2],loops[1])

	h_wheel = calarrayforhelixwheel(data[0],data[2])

	for hw in h_wheel[1]:
		color_array = h_wheel[1][hw]
		res_array = h_wheel[0][hw]
		l = len(h_wheel[0][hw])
		writehelixwheel(hwname+str(hw)+'.pov',color_array,res_array,l,'Black','White')
		writehelixwheel(hwname+str(hw)+'_1.pov',color_array,res_array,l,'White','Black')
	
	
	writeimage(data[0],data[2],xcoords[1],ycoords,loops[0],lcoords[0],lcoords[1],lcoords[2],'Black','White',povname+'.pov')
	writeimage(data[0],data[2],xcoords[1],ycoords,loops[0],lcoords[0],lcoords[1],lcoords[2],'White','Black',povname+'1.pov')
	
	if len(data[3]) > 0:
		modify_povfile(povname+'.pov',newcoords[0],newcoords[1],data[0],ycoords,povname+'nc.pov','White',lcoords[1],lcoords[0],lcoords[2],loops[0],data[3])
		modify_povfile(povname+'1.pov',newcoords[0],newcoords[1],data[0],ycoords,povname+'nc1.pov','Black',lcoords[1],lcoords[0],lcoords[2],loops[0],data[3])



def createtmxdata(tmxname,toponame,tmxhwname1,tmxhwname2): #processes the content of the tmx file and calculates the pov files for the helical wheels with tmx and conservation coloring
	
	tmxdata = readTMX(tmxname)

	data = datainput(toponame)
	tmxhw = caltmxarrayforhelixwheel(data[0],data[2],tmxdata[0],tmxdata[1])
	
	for w in tmxhw[0]:
		tmxcolor_array = tmxhw[1][w]
		conscolor_array = tmxhw[2][w]
		tmxres_array = tmxhw[0][w]
		l = len(tmxhw[0][w])
		writehelixwheel(tmxhwname1+str(w)+'.pov',tmxcolor_array,tmxres_array,l,'Black','White')
		writehelixwheel(tmxhwname1+str(w)+'_1.pov',tmxcolor_array,tmxres_array,l,'White','Black')
		writehelixwheel(tmxhwname2+str(w)+'.pov',conscolor_array,tmxres_array,l,'Black','White')
		writehelixwheel(tmxhwname2+str(w)+'_1.pov',conscolor_array,tmxres_array,l,'White','Black')
	




#createtmxdata('/home/nadine/Desktop/Master_komplett/Master/tmx/tmxfiles/1bcc_c_tmx','/home/nadine/Desktop/HiWi/TopoView_tmx/examples/topology1.top')