#version 3.6;
global_settings { assumed_gamma 1.3 }


#include "colors.inc"
#include "textures.inc"
//----------------------------------------------------------------------
// background -------------------------------
#macro Background(co)
union{
text {ttf  "DejaVuSans.ttf" "Periplasm" 0.2, 0 
	pigment{co}
	scale<4,3.5,2.5>
	translate<4,-25,0>
	no_shadow }
text {ttf  "DejaVuSans.ttf" "Cytoplasm" 0.2, 0 
	pigment{co}
	scale<4,3.5,2.5>
	translate<4,25,0>
	no_shadow }
difference {
	box {
		<-20.0,-15.0,-2.0>, <401.0,15.0,41.0>
		pigment {color BrightGold transmit 0.55}//rgb <0.9, 0.9, 0.9>
	}
	box {
		<-19.0,-14.7,-3.0>, <400.0,14.7,40.0>
		pigment {color BrightGold transmit 0.55}
	}
}}
#end

#macro lipid1() 
union{
sphere  {<0,0.8,0>,2 scale <1,1,1>
 texture{pigment{color Yellow}
         finish {ambient 0.1 diffuse 0.9 phong 1}}}
cylinder {<0,-1,0>,<1.75,-3.0,0>,0.4 
texture{pigment{color Yellow}
	finish {ambient 0.1 diffuse 0.9 phong 1}
}}
cylinder {<1.85,-2.8,0>,<0,-4.8,0>,0.4 
texture{pigment{color Yellow}
	finish {ambient 0.1 diffuse 0.9 phong 1}
}}
cylinder {<0,-4.6,0>,<1.75,-6.6,0>,0.4 
texture{pigment{color Yellow}
	finish {ambient 0.1 diffuse 0.9 phong 1}
}}
cylinder {<1.85,-6.4,0>,<0,-8.4,0>,0.4 
texture{pigment{color Yellow}
	finish {ambient 0.1 diffuse 0.9 phong 1}
}}
cylinder {<0,-8.2,0>,<1.75,-10.2,0>,0.4 
texture{pigment{color Yellow}
	finish {ambient 0.1 diffuse 0.9 phong 1}
}}
cylinder {<1.85,-10,0>,<0,-12,0>,0.4 
texture{pigment{color Yellow}
	finish {ambient 0.1 diffuse 0.9 phong 1}
}}
cylinder {<0,-11.8,0>,<1.75,-13.8,0>,0.4 
texture{pigment{color Yellow}
	finish {ambient 0.1 diffuse 0.9 phong 1}
}}
cylinder {<1.85,-13.6,0>,<0,-15.6,0>,0.4 
texture{pigment{color Yellow}
	finish {ambient 0.1 diffuse 0.9 phong 1}
}}
}
#end

#macro lipid2()
object{lipid1() translate<0,0,0> rotate<0,0,180>}
#end


#macro bilayer()
union{
object{lipid1() translate<-1,16,-1>}
object{lipid1() translate<-1,16,3>}
object{lipid1() translate<-1,16,7>}
object{lipid1() translate<-1,16,11>}
object{lipid1() translate<-1,16,15>}
object{lipid1() translate<-1,16,19>}
object{lipid1() translate<-1,16,23>}
object{lipid1() translate<-1,16,27>}
object{lipid1() translate<-1,16,31>}
object{lipid1() translate<-1,16,35>}
object{lipid1() translate<-1,16,39>}
object{lipid2() translate<1,-16,-1>}
object{lipid2() translate<1,-16,3>}
object{lipid2() translate<1,-16,7>}
object{lipid2() translate<1,-16,11>}
object{lipid2() translate<1,-16,15>}
object{lipid2() translate<1,-16,19>}
object{lipid2() translate<1,-16,23>}
object{lipid2() translate<1,-16,27>}
object{lipid2() translate<1,-16,31>}
object{lipid2() translate<1,-16,35>}
object{lipid2() translate<1,-16,39>}
object{lipid1() translate<-4,16,0>}
object{lipid1() translate<-4,16,4>}
object{lipid1() translate<-4,16,8>}
object{lipid1() translate<-4,16,12>}
object{lipid1() translate<-4,16,16>}
object{lipid1() translate<-4,16,20>}
object{lipid1() translate<-4,16,24>}
object{lipid1() translate<-4,16,28>}
object{lipid1() translate<-4,16,32>}
object{lipid1() translate<-4,16,36>}
object{lipid1() translate<-4,16,40>}
object{lipid2() translate<-3,-16,0>}
object{lipid2() translate<-3,-16,4>}
object{lipid2() translate<-3,-16,8>}
object{lipid2() translate<-3,-16,12>}
object{lipid2() translate<-3,-16,16>}
object{lipid2() translate<-3,-16,20>}
object{lipid2() translate<-3,-16,24>}
object{lipid2() translate<-3,-16,28>}
object{lipid2() translate<-3,-16,32>}
object{lipid2() translate<-3,-16,36>}
object{lipid2() translate<-3,-16,40>}
}
#end


#macro membrane(w,co)
union{
object{Background(co)}
object{bilayer()}
object{bilayer() translate<w,0,0>}
}
#end

//protein ---------------------------------------------------------------

//----------------helices-------------------------------------------
#macro residue(c)
 sphere  {<0,0,0>,0.8 scale <1,1,1>  translate<0,0,0> 
 texture{pigment{color c}
         finish {ambient 0.1 diffuse 0.9 phong 1}}}
#end

#macro residue2(c,r)
 sphere  {<0,0,0>,r scale <1,1,1>  translate<0,0,0> 
 texture{pigment{color c}}}
         //finish {ambient 0.1 diffuse 0.9 phong 1}}}
#end


#macro helpball()
 sphere  {<0,0,0>,0.08 scale <1,1,1>  translate<0,0,0> 
 texture{pigment{color Blue}
         finish {ambient 0.1 diffuse 0.9 phong 1}}}
#end


#macro alphaHelixperi(length,c,c1)
union{
#declare Radius   = 2.5;
#declare N_rev1    = (length-1)*200;
#declare N_rev    = length; //number of turns
#declare N_p_rev1  = 720; //number of helpballs per turn
#declare N_p_rev  = 3.6; //number of residues per turn
#declare H_p_rev  = 5.4;
#declare H1 = H_p_rev/N_p_rev1;
#declare H = H_p_rev/N_p_rev;
//------------helpline-------------------------------------
union{
#declare Nr = 0;                // start
#declare EndNr = N_rev1;       // end
#while (Nr< EndNr) 
 object{helpball()
        translate<Radius,Nr*H1,0> 
        rotate<0,Nr * 360/N_p_rev1 ,0>
	} 
 #declare Nr = Nr + 1;  // next Nr
#end // --------------- end of loop -----------------------
rotate<0,0,0>}

//----------------------residues----------------------------
union{
#declare Nr = 0;                // start
#declare EndNr = N_rev;         // end
#while (Nr< EndNr)
 #if ((Nr = 0) | (Nr > EndNr-2))
 object{residue(c1)
        translate<Radius,Nr*H,0> 
        rotate<0,Nr * 360/N_p_rev ,0>
	}
 #else
 object{residue(c)
        translate<Radius,Nr*H,0> 
        rotate<0,Nr * 360/N_p_rev ,0>
	}
 #end
 #declare Nr = Nr + 1;  // next Nr
#end // --------------- end of loop -----------------------
rotate<0,0,0>}
}
#end



#macro alphaHelixperi_1(length,ac)
union{
#declare Radius   = 2.5;
#declare N_rev1    = (length-1)*200;
#declare N_rev    = length; //number of residues
#declare N_p_rev1  = 720; //number of helpballs per turn
#declare N_p_rev  = 3.6; //number of residues per turn
#declare H_p_rev  = 5.4;
#declare H1 = H_p_rev/N_p_rev1;
#declare H = H_p_rev/N_p_rev;
//------------helpline-------------------------------------
union{
#declare Nr = 0;                // start
#declare EndNr = N_rev1;       // end
#while (Nr< EndNr) 
 object{helpball()
        translate<Radius,Nr*H1,0> 
        rotate<0,Nr * 360/N_p_rev1 ,0>
	} 
 #declare Nr = Nr + 1;  // next Nr
#end // --------------- end of loop -----------------------
rotate<0,0,0>}

//----------------------residues----------------------------
union{
#declare Nr = 0;                // start
#declare EndNr = N_rev;         // end
#while (Nr< EndNr)
 object{residue(ac[Nr])
        translate<Radius,Nr*H,0> 
        rotate<0,Nr * 360/N_p_rev ,0>
 }
 #declare Nr = Nr + 1;  // next Nr
#end // --------------- end of loop -----------------------
rotate<0,0,0>}
}
#end




#macro alphaHelixcyto(length,c,c1)
object{alphaHelixperi(length,c,c1) translate<0,0,0> rotate<180,0,0>}
#end


#macro alphaHelixcyto_1(length,ac)
object{alphaHelixperi_1(length,ac) translate<0,0,0> rotate<180,0,0>}
#end


#macro alphaHelixinterface(length,c,c1)
object{alphaHelixperi(length,c,c1) translate<0,0,0> rotate<90,0,0> rotate<0,90,0>}
#end


#macro alphaHelixinterface_1(length,ac)
object{alphaHelixperi_1(length,ac) translate<0,0,0> rotate<90,0,0> rotate<0,90,0>}
#end

#macro shwithloopperi(x1,y1,z1,helix1,len,helix2,c,c1) //position, length of helix 1, length of loop, length of helix 2,color of residue
union{
object{alphaHelixperi(helix1,c,c1) translate<x1,y1,z1>}
#declare start = y1+2+(helix1/3.6*5.4);
#declare ends = (y1+2+(helix1/3.6*5.4))+(len-1)*2.2;
#while (start <= ends)
object{residue(c)
	translate<x1,start,z1>}
#declare start = start + 2.2;
#end
object{alphaHelixperi(helix2,c,c1) translate<x1,start+0.2,z1>}
}
#end

#macro shwithloopperi_1(x1,y1,z1,helix1,len,helix2,ac1,ac2,ac3) //position, length of helix 1, length of loop, length of helix 2,color of residue
union{
object{alphaHelixperi_1(helix1,ac1) translate<x1,y1,z1>}
#declare start = y1+2+(helix1/3.6*5.4);
#declare ends = (y1+2+(helix1/3.6*5.4))+(len-1)*2.2;
#declare Nr = 0;
#while (start <= ends)
object{residue(ac2[Nr])
	translate<x1,start,z1>}
#declare start = start + 2.2;
#declare Nr = Nr + 1;
#end
object{alphaHelixperi_1(helix2,ac3) translate<x1,start+0.2,z1>}
}
#end


#macro shwithloopcyto(x1,y1,z1,helix1,len,helix2,c,c1) //position, length of helix 1, length of loop, length of helix 2
union{
object{alphaHelixcyto(helix1,c,c1) translate<x1,y1,z1>}
#declare start = y1-2-(helix1/3.6*5.4);
#declare ends = (y1-2-(helix1/3.6*5.4))-(len-1)*2.2;
#while (start >= ends)
object{residue(c)
	translate<x1,start,z1>}
#declare start = start - 2.2;
#end
object{alphaHelixcyto(helix2,c,c1) translate<x1,start-0.2,z1>}
}
#end


#macro shwithloopcyto_1(x1,y1,z1,helix1,len,helix2,ac1,ac2,ac3) //position, length of helix 1, length of loop, length of helix 2
union{
object{alphaHelixcyto_1(helix1,ac1) translate<x1,y1,z1>}
#declare start = y1-2-(helix1/3.6*5.4);
#declare ends = (y1-2-(helix1/3.6*5.4))-(len-1)*2.2;
#declare Nr = 0;
#while (start >= ends)
object{residue(ac2[Nr])
	translate<x1,start,z1>}
#declare Nr = Nr + 1;
#declare start = start - 2.2;
#end
object{alphaHelixcyto_1(helix2,ac3) translate<x1,start-0.2,z1>}
}
#end


//---------------------Helix Wheel--------------------------


#macro helixwheel(a,n,s,f)
union
{
union
{
#declare helixr = array[40]{<-24.62,-4.341,2.0>,<8.55,-23.492,4.0>,<21.65,12.499,6.0>,<-16.069,19.151,8.0>,<-16.07,-19.15,10.0>,<21.65,-12.5,12.0>,<8.551,23.492,14.0>,<-24.62,4.342,16.0>,<-0.001,-25.0,18.0>,<24.62,4.34,20.0>,<-8.549,23.492,22.0>,<-21.651,-12.498,24.0>,<16.068,-19.152,26.0>,<16.071,19.15,28.0>,<-21.65,12.501,30.0>,<-8.552,-23.492,32.0>,<24.62,-4.343,34.0>,<0.002,25.0,36.0>,<-24.621,-4.339,38.0>,<8.548,-23.493,40.0>,<21.652,12.498,42.0>,<-16.068,19.153,44.0>,<-16.072,-19.15,46.0>,<21.65,-12.502,48.0>,<8.553,23.492,50.0>,<-24.62,4.344,52.0>,<-0.003,-25.0,54.0>,<24.621,4.338,56.0>,<-8.547,23.494,58.0>,<-21.653,-12.497,60.0>,<16.067,-19.154,62.0>,<16.073,19.149,64.0>,<-21.649,12.504,66.0>,<-8.555,-23.491,68.0>,<24.62,-4.346,70.0>,<0.005,25.001,72.0>,<-24.622,-4.336,74.0>,<8.546,-23.495,76.0>,<21.654,12.496,78.0>,<-16.066,19.155,80.0>};
union
{
#declare Nr = 0;      // start
#declare EndNr = n;  // end
#while (Nr< n)
 object{residue2(a[Nr],2)
       translate helixr[Nr]}
 #declare Nr = Nr + 1;
#end // --------- end of loop -------
}
union
{
#declare Nr1 = 0;      // start
#declare EndNr1 = n;  // end
#while (Nr1< EndNr1-1)
 #declare P1 = helixr[Nr1];
 #declare P2 = helixr[Nr1+1];
 cylinder{ P1, P2, 0.09 pigment{color Green} no_shadow}
 #declare Nr1 = Nr1 + 1;
#end // --------- end of loop -------
}translate<2,0.7,0>}
union
{
#declare helixl = array[40]{<-30.037,-5.296,2.0>,<10.431,-28.661,4.0>,<26.414,15.249,6.0>,<-19.604,23.365,8.0>,<-19.606,-23.363,10.0>,<26.413,-15.251,12.0>,<10.433,28.66,14.0>,<-30.036,5.298,16.0>,<-0.002,-30.5,18.0>,<30.037,5.294,20.0>,<-10.429,28.661,22.0>,<-26.415,-15.247,24.0>,<19.602,-23.366,26.0>,<19.607,23.362,28.0>,<-26.412,15.252,30.0>,<-10.434,-28.659,32.0>,<30.035,-5.299,34.0>,<0.003,30.499,36.0>,<-30.036,-5.293,38.0>,<10.428,-28.661,40.0>,<26.415,15.247,42.0>,<-19.602,23.366,44.0>,<-19.607,-23.362,46.0>,<26.412,-15.252,48.0>,<10.434,28.659,50.0>,<-30.035,5.299,52.0>,<-0.003,-30.499,54.0>,<30.036,5.293,56.0>,<-10.428,28.661,58.0>,<-26.415,-15.247,60.0>,<19.602,-23.366,62.0>,<19.607,23.362,64.0>,<-26.412,15.252,66.0>,<-10.434,-28.659,68.0>,<30.035,-5.299,70.0>,<0.003,30.499,72.0>,<-30.036,-5.293,74.0>,<10.428,-28.661,76.0>,<26.415,15.247,78.0>,<-19.602,23.366,80.0>};
#declare Nr2 = 0;      // start
#declare EndNr2 = n;  // end
#while (Nr2< EndNr2)
 text {ttf  "DejaVuSans.ttf" s[Nr2] 0.2, 0 
	pigment{f}
	scale<2,2,0.5>
	translate helixl[Nr2]
	no_shadow}
 #declare Nr2 = Nr2 + 1;
#end // --------- end of loop -------
}
difference
{
cylinder{ <0,0,3>, <0,0,100> 32 pigment{color BrightGold transmit 0.65} no_shadow}
cylinder{ <0,0,2>, <0,0,101> 31.7 pigment{color BrightGold transmit 0.65} no_shadow} translate<1.3,0.4,0>
}
}
#end







//---------------------globular domain--------------------------


#macro globdomain(newnum,x1,y1,z1)
#if ((1 <= newnum) & (newnum<= 20))
#declare dis = 3.5;
#declare res = 6;
#end
#if ((21 <= newnum) & (newnum<= 40))
#declare dis = 4;
#declare res = 7;
#end
#if ((41 <= newnum) & (newnum<= 60))
#declare dis = 5;
#declare res = 8;
#end
#if (61 <= newnum)
#declare dis = 6;
#declare res = 9;
#end
union{
  text {ttf  "DejaVuSans.ttf" "G" 0.2, 0 
	pigment{White}
	scale<4,3.5,2.5>
	translate<-0.9,-0.9,-res>}
	
  sphere{<0,0,0>,res*0.8
    texture{
      pigment{color Blue}
      finish {ambient 0.15 diffuse 0.855 phong 1}
    }// end of texture
    scale<1.7,1,1>
  }// end of sphere	
}
#if (y1 < 0)
translate<x1,y1-dis,z1>
#else
translate<x1,y1+dis,z1>
#end

#end




//-----------------------loops------------------------------------


#macro loopcurve(r,a,w,c)
union{
#declare Radius = r;
#declare Nr = 0;      // start
#declare EndNr = a;  // end
#while (Nr<= EndNr)
object{residue(c)
       translate<Radius,0,0>
       rotate<0,0,Nr* w/EndNr>}
#declare Nr = Nr + 1;
#end // --------- end of loop -------
}
#end

#macro loopcurve2(r,a,w,c)
object{loopcurve(r,a,w,c) translate<0,0,0> rotate<0,0,180>}
#end


#macro cytoloop(x1,y1,z1,x2,y2,z2,num1,num2,r,ra,nr,w,c)
union{
#if (((num1+num2) > 15) & (ra = 6))
#declare res = (num1 + num2);
#if (num1 = num2) // | (abs(num1 -num2) <= 1))
#declare res = res-10;
#declare n1 = 5;
#declare n2 = 5;
#else
#if (num1 > num2)
#declare d = num1 - num2;
#declare res = res-10-d;
#declare n1 = 5+d;
#declare n2 = 5;
#else
#declare d = num2 - num1;
#declare res = res-10-d;
#declare n1 = 5;
#declare n2 = 5+d;
#end
#end
#declare start1 = y1;
#declare end1 = y1 + (4*(n1-1));
#while (start1 <= end1)
object{residue(c)
	translate<x1,start1,z1>}
#declare start1 = start1 + 4;
#end
#declare start2 = y2;
#declare end2 = y2 + (4*(n2-1));
#while (start2 <= end2)
object{residue(c)
	translate<x2,start2,z2>}
#declare start2 = start2 + 4;
#end
object{globdomain(res,x1+((x2-x1)/2),start1,z2)}
#else
#declare start1 = y1;
#declare end1 = y1 + (4*(num1-1));
#while (start1 <= end1)
object{residue(c)
	translate<x1,start1,z1>}
#declare start1 = start1 + 4;
#end
#declare start2 = y2;
#declare end2 = y2 + (4*(num2-1));
#while (start2 <= end2)
object{residue(c)
	translate<x2,start2,z2>}
#declare start2 = start2 + 4;
#end
object{loopcurve(ra,nr,w,c) translate<0,0,0> rotate<0,180,0> translate<x1+((x2-x1)/2),((start1+start2)/2)+0.3,z2>}
#end
}
#end


#macro periloop(x1,y1,z1,x2,y2,z2,num1,num2,r,ra,nr,w,c)

union{
#if (((num1+num2) > 15) & (ra=6))
#declare res = (num1 + num2);
#if (num1 = num2) //| (abs(num1 -num2) <= 1))
#declare res = res-10;
#declare n1 = 5;
#declare n2 = 5;
#else
#if (num1 > num2)
#declare d = num1 - num2;
#declare res = res-10-d;
#declare n1 = 5+d;
#declare n2 = 5;
#else
#declare d = num2 - num1;
#declare res = res-10-d;
#declare n1 = 5;
#declare n2 = 5+d;
#end
#end
#declare start1 = y1;
#declare end1 = y1 - (4*(n1-1));
#while (start1 >= end1)
object{residue(c)
	translate<x1,start1,z1>}
#declare start1 = start1 - 4;
#end
#declare start2 = y2;
#declare end2 = y2 - (4*(n2-1));
#while (start2 >= end2)
object{residue(c)
	translate<x2,start2,z2>}
#declare start2 = start2 - 4;
#end
object{globdomain(res,x1+((x2-x1)/2),start1,z2)}
#else
#declare start1 = y1;
#declare end1 = y1 - (4*(num1-1));
#while (start1 >= end1)
object{residue(c)
	translate<x1,start1,z1>}
#declare start1 = start1 - 4;
#end
#declare start2 = y2;
#declare end2 = y2 - (4*(num2-1));
#while (start2 >= end2)
object{residue(c)
	translate<x2,start2,z2>}
#declare start2 = start2 - 4;
#end
object{loopcurve2(ra,nr,w,c) translate<x1+((x2-x1)/2),((start1+start2)/2)-0.3,z2>}
#end
}
#end


#macro startendloopcyto(x1,y1,z1,num,c)
union{
#if (num > 8)
#declare start1 = y1;
#declare end1 = y1 + 28.8;
#while (start1 <= end1)
object{residue(c)
	translate<x1,start1,z1>}
#declare start1 = start1 + 4;
#end
#declare res = num - 8;
object{globdomain(res,x1,start1,z1)}
#else
#declare start1 = y1;
#declare end1 = y1 + (4*num);
#while (start1 <= end1)
object{residue(c)
	translate<x1,start1,z1>}
#declare start1 = start1 + 4;
#end
#end
}
#end

#macro startendloopperi(x1,y1,z1,num,c)
union{
#if (num > 8)
#declare start1 = y1;
#declare end1 = y1 - 28.8;
#while (start1 >= end1)
object{residue(c)
	translate<x1,start1,z1>}
#declare start1 = start1 - 4;
#end
#declare res = num - 8;
object{globdomain(res,x1,start1,z1)}
#else
#declare start1 = y1;
#declare end1 = y1 - (4*num);
#while (start1 >= end1)
object{residue(c)
	translate<x1,start1,z1>}
#declare start1 = start1 - 4;
#end
#end
}
#end


#macro reentantloopperi(x1,y1,z1,x2,y2,z2,num1,num2,nr,c)
union{
#declare start1 = y1;
#declare end1 = y1 + (4*(num1));
#while (start1 <= end1)
object{residue(c)
	translate<x1+6,start1,z1>}
#declare start1 = start1 + 4;
#end
#declare start2 = y2;
#declare end2 = y2 + (4*(num2));
#while (start2 <= end2)
object{residue(c)
	translate<x2-6,start2,z2>}
#declare start2 = start2 + 4;
#end
object{loopcurve2(3,2,180,c) translate<x1+3,y1,z2>}
object{loopcurve2(3,2,180,c) translate<x2-3,y2,z2>}
#if (start2 = y1)
object{loopcurve2(6,nr,180,c) translate<x1+12,((start1+start2)/2)+4,z2>}
#else
object{loopcurve(6,nr,180,c) translate<x1+12,((start1+start2)/2)+0.3,z2>}
#end
}
#end


#macro reentantloopcyto(x1,y1,z1,x2,y2,z2,num1,num2,nr,c)
union{
#declare start1 = y1;
#declare end1 = y1 - (4*(num1));
#while (start1 >= end1)
object{residue(c)
	translate<x1+6,start1,z1>}
#declare start1 = start1 - 4;
#end
#declare start2 = y2;
#declare end2 = y2 - (4*(num2));
#while (start2 >= end2)
object{residue(c)
	translate<x2-6,start2,z2>}
#declare start2 = start2 - 4;
#end
object{loopcurve(3,2,180,c) translate<x1+3,y1,z2>}
object{loopcurve(3,2,180,c) translate<x2-3,y2,z2>}
#if (start2 = y1)
object{loopcurve2(6,nr,180,c) translate<x1+12,((start1+start2)/2)-4,z2>}
#else
object{loopcurve2(6,nr,180,c) translate<x1+12,((start1+start2)/2)-0.3,z2>}
#end
}
#end


//-----helix labels---------------------------------------------------

#macro helixlabel(s,co,x1,y1)
text {ttf  "DejaVuSans.ttf" s 0.2, 0 
	pigment{co}
	scale<4,3.5,2.5>
	translate<x1,y1,-3>
	no_shadow}
#end


#macro helixlabel1(s,co,x1,y1)
#if (y1 > 0)
 text {ttf  "DejaVuSans.ttf" s 0.2, 0 
	pigment{co}
	scale<2,2,0.8>
	translate<x1,y1+1,-3>
	no_shadow}
#else
 text {ttf  "DejaVuSans.ttf" s 0.2, 0 
	pigment{co}
	scale<2,2,0.8>
	translate<x1,y1-1.75,-3>
	no_shadow}
#end
#end

//-------------------------------------------------------- end of file 
