from Tkinter import*
import sys
from os import*
from string import*
import tkMessageBox
import tkFileDialog
import imagetopo
import controldata
from threading import*




class Topowidget(object): # creation window
	
	def popupmenu(self,event):
		self.popup.post(event.x_root,event.y_root)
		
	
	def __init__(self):
		self.topowid = Tk()
		self.topowid.geometry('390x750')
		self.topowid.resizable(False,False)
		self.topowid.title('Create Topology')
		
		self.patht = getcwd()
		
		self.f1 = Frame(self.topowid)
		self.f1.grid(row=0,column=0)
		
		self.labelname = Label(self.f1, text='Protein name:')
		self.labelname.grid(row=0,column=0, pady=5, sticky=NW )
		
		self.protname = Entry(self.f1, width=30, bg = 'white')
		self.protname.grid(row=0,column=1, pady=5, sticky=NW )
		
		self.labelseq = Label(self.f1, text='Sequence in fasta format:')
		self.labelseq.grid(row=1,columnspan=2, sticky=NW, pady=5 )
		
		self.topcanvas = Canvas(self.f1, width='3c', height='2c')
		self.topcanvas.grid(row=2,columnspan=2, pady=5)
		
		self.scroll = Scrollbar(self.topcanvas)
		self.scroll.grid(row=0,column=1,ipady=10)
		
		self.aaseq = Text(self.topcanvas, height=4, width=50, bg = 'white', yscrollcommand=self.scroll.set)
		self.aaseq.grid(row=0,column=0, pady=5 )
		
		self.scroll.config(command=self.aaseq.yview)
		
		self.labelaaopen = Label(self.f1, text='Open .fasta file')
		self.labelaaopen.grid(row=3,column=0, sticky=NW, pady=5)
		self.browsebutton = Button(self.f1, text='Browse ...', command=self.browse1)
		self.browsebutton.grid(row=3,column=1, sticky=NE)
		
		
		self.f2 = Frame(self.topowid, relief=RIDGE)
		self.f2.grid(row=1,column=0)
		
		self.labeltmh = Label(self.f2, text='Long TM Helices (Idenifier Startresidue Endresidue):')
		self.labeltmh.grid(row=0,columnspan=2, pady=5, sticky=NW)
		
		self.topcanvas1 = Canvas(self.f2, width='3c', height='2c')
		self.topcanvas1.grid(row=1,columnspan=2, pady=5)
		
		self.scroll1 = Scrollbar(self.topcanvas1)
		self.scroll1.grid(row=0,column=1,ipady=7)
		
		self.tmh = Text(self.topcanvas1, height=3, width=50, bg = 'white', yscrollcommand=self.scroll1.set)
		self.tmh.grid(row=0,column=0, pady=5 )

		self.scroll1.config(command=self.tmh.yview)	
		
		self.labeltmhopen = Label(self.f2, text='Open TMHMM2.0 file')
		self.labeltmhopen.grid(row=2,column=0, sticky=NW, pady=5)
		self.browsebutton1 = Button(self.f2, text='Browse ...', command=self.browse2)
		self.browsebutton1.grid(row=2,column=1, sticky=NE)
		
		self.labelstmh = Label(self.f2, text='Short TM Helices (Idenifier Startresidue Endresidue):')
		self.labelstmh.grid(row=3, columnspan=2, pady=5, sticky=NW)
		
		self.topcanvas2 = Canvas(self.f2, width='3c', height='2c')
		self.topcanvas2.grid(row=4,columnspan=2, pady=5)
		
		self.scroll2 = Scrollbar(self.topcanvas2)
		self.scroll2.grid(row=0,column=1)
		
		self.stmh = Text(self.topcanvas2, height=2, width=50, bg='white', yscrollcommand=self.scroll2.set)
		self.stmh.grid(row=0,column=0, pady=5 )

		self.scroll2.config(command=self.stmh.yview)
		
		self.labelih = Label(self.f2, text='Interface TM Helices (Idenifier Startresidue Endresidue):')
		self.labelih.grid(row=5, columnspan=2, pady=5, sticky=NW)
		
		self.topcanvas3 = Canvas(self.f2, width='3c', height='2c')
		self.topcanvas3.grid(row=6,columnspan=2, pady=5)
		
		self.scroll3 = Scrollbar(self.topcanvas3)
		self.scroll3.grid(row=0,column=1)
		
		self.ih = Text(self.topcanvas3, height=2, width=50, bg='white', yscrollcommand=self.scroll3.set)
		self.ih.grid(row=0,column=0, pady=5 )
				
		self.scroll3.config(command=self.ih.yview)
		
		self.labelrl = Label(self.f2, text='Reentrant Loops (Helix1 Helix2):')
		self.labelrl.grid(row=7, columnspan=2, pady=5, sticky=NW)
		
		self.topcanvas4 = Canvas(self.f2, width='3c', height='2c')
		self.topcanvas4.grid(row=8,columnspan=2, pady=5)
		
		self.scroll4 = Scrollbar(self.topcanvas4)
		self.scroll4.grid(row=0,column=1)
		
		self.rl = Text(self.topcanvas4, height=2, width=50, bg='white', yscrollcommand=self.scroll4.set)
		self.rl.grid(row=0,column=0, pady=5 )
				
		self.scroll4.config(command=self.rl.yview)
		
		self.f3 = Frame(self.topowid, relief=RIDGE)
		self.f3.grid(row=2,column=0, sticky=NW)
		
		self.labelnc = Label(self.f3, text='Long non contacting consecutive Helices:')
		self.labelnc.grid(row=0, columnspan=4, pady=5, sticky=NW)
		
		self.helix1 = Label(self.f3, text='Helix 1 ID:')
		self.helix1.grid(row=1,column=0, pady=10, sticky=NW )
		
		self.helix2 = Label(self.f3, text='Helix 2 ID:')
		self.helix2.grid(row=1,column=2, pady=10 , sticky=NE)

		self.h1id = Entry(self.f3, width=5, bg = 'white')
		self.h1id.grid(row=1,column=1, pady=10, sticky=NW )
		
		self.h2id = Entry(self.f3, width=5, bg = 'white')
		self.h2id.grid(row=1,column=3, pady=10, sticky=NE )
		
		
		self.f4 = Frame(self.topowid, relief=RIDGE)
		self.f4.grid(row=3,column=0, sticky=NW)
		
		self.val = -1
		self.pclabel = Label(self.f4, text='Position of the N-terminus (if available):', pady=10)
		self.pclabel.grid(row=0,column=0, sticky=N+W+E)
		self.pericyto1 = Radiobutton(self.f4, text='Periplasm', variable=self.val, value=0, command=self.setval0)
		self.pericyto1.grid(row=1,column=0, sticky=NW)
		self.pericyto2 = Radiobutton(self.f4, text='Cytoplasm', variable=self.val, value=1, command=self.setval1)
		self.pericyto2.grid(row=2,column=0, sticky=NW)	

		
		self.createbutton = Button(self.f4, text='Create', command=self.control)
		self.createbutton.grid(row=2,column=1, sticky=E)
		
		self.popup = Menu(self.aaseq,tearoff=0)
		self.popup.add_command(label='Paste', command=self.pastein)
		self.aaseq.bind('<Button-3>',self.popupmenu)
		
		self.topowid.mainloop()

	
	
	
	def browse1(self): # opens a file dialog to read in a fasta file
		self.aaopen = tkFileDialog.askopenfilename()
		
		fastafile = file(self.aaopen,'r')
		fastafile_lst = fastafile.readlines()
		fastafile.close()
		con = 1
		if self.aaseq.get('1.0',END) != '\n':
			con = tkMessageBox.askokcancel("Confirmation", "Do you really wish to load a file?\nThe sequence you have already pasted in will be canceled!")
		if con == 1:
			self.aaseq.delete('1.0',END)
			for line in fastafile_lst:
				if line.startswith('>'):
					self.protname.delete('0',END)
					self.protname.insert(END,rstrip(line[1:]))
				else:
					self.aaseq.insert(END,line)

	
	def browse2(self): # opens a file dialog to read in a TMHMM 2.0 server output file
		self.tmopen = tkFileDialog.askopenfilename()

		tmhmmfile =  file(self.tmopen,'r')
		tf_lst = tmhmmfile.readlines()
		tmhmmfile.close()
		tmcounter = 1
		con1 = 1
		if self.tmh.get('1.0',END) != '\n':
			con1 = tkMessageBox.askokcancel("Confirmation", "Do you really wish to load a file?\nThe TM helices you have already pasted in will be canceled!")
		if con1 == 1:
			if tf_lst[0].startswith('#'): # extensive version of TMHMM 2.0 file
				tf = tf_lst[0].split()
				if len(tf) == 4:
					if tf[2] == 'Length:':
						self.tmh.delete('1.0',END)
						for line1 in tf_lst:
							l1 = line1.split()
							if l1[0] != '#' or l1[0] != '\n':
								if l1[2] == 'TMhelix':
									self.tmh.insert(END,str(tmcounter)+'\t'+l1[3]+'\t'+l1[4]+'\n')
									tmcounter = tmcounter + 1
					else:
						tkMessageBox.showwarning('Input Problems', 'The file is not a TMHMM 2.0 file')
				else:
					tkMessageBox.showwarning('Input Problems', 'The file is not a TMHMM 2.0 file')
			elif len(tf_lst[0].split()) > 1: # short version of TMHMM 2.0 file
				if tf_lst[0].split()[1].startswith('len='):
					self.tmh.delete('1.0',END)
					tf = tf_lst[0].split()
					new = lstrip(tf[5],'Topology=').split('o')
					new1 = map(lambda n: n.split('i'),new)
					for n in new1:
						for h in n:
							if h != '':
								helix = h.split('-')
								self.tmh.insert(END,str(tmcounter)+'\t'+helix[0]+'\t'+helix[1]+'\n')
								tmcounter = tmcounter + 1
				else:
					tkMessageBox.showwarning('Input Problems', 'The file is not a TMHMM 2.0 file')
			else:
				tkMessageBox.showwarning('Input Problems', 'The file is not a TMHMM 2.0 file')


	
	def control(self): # controls the input the user made
		
		fastalst = []
		
		if self.aaseq.get('1.0',END).startswith('>'):
			fastastr = self.aaseq.get('2.0',END)
			if fastastr.split() == '\n':
				pass
			else:
				fastalst.append(join(fastastr.split(),''))
		else:
			fastastr = self.aaseq.get('1.0',END)
			if fastastr == '\n':
				pass
			else:
				fastalst.append(join(fastastr.split(),''))

		TMstring=self.tmh.get(1.0,END)
		TM_lst1 = TMstring.split('\n')
		TM_lst = filter(lambda y: bool(y),map(lambda x: x.split(),TM_lst1))
		
		STMstring=self.stmh.get(1.0,END)
		STM_lst1 = STMstring.split('\n')
		STM_lst = filter(lambda y: bool(y),map(lambda x: x.split(),STM_lst1))
		
		IHstring=self.ih.get(1.0,END)
		IH_lst1 = IHstring.split('\n')
		IH_lst = filter(lambda y: bool(y),map(lambda x: x.split(),IH_lst1))
		
		RLstring=self.rl.get(1.0,END)
		RL_lst1 = RLstring.split('\n')
		RL_lst = filter(lambda y: bool(y),map(lambda x: x.split(),RL_lst1))
		
		NC_lst = []
		NC_lst.append(self.h1id.get())
		NC_lst.append(self.h2id.get())

		
		faults = controldata.controluser(fastalst, TM_lst, STM_lst, IH_lst, RL_lst, NC_lst) # modul controldata is called
		
		if len(faults) == 0:
			self.readinput()
			tkMessageBox.showinfo('Please wait...','Computations running')
		else:
			for f in faults:
				if tkMessageBox.showwarning('Input Problems',f) == 'ok':
					continue


	def readinput(self): # creates a topology file with the input of the user

		self.imagedir = getcwd()+'/images'
		topofile = file(self.imagedir+'/topology.txt','w')
		
		topofile.write('name:'+self.protname.get()+'\n')
		
		if self.aaseq.get('1.0',END).startswith('>'):
			topofile.write('sequence\n>>\n'+self.aaseq.get('2.0',END)+'>>\n')
		else:
			topofile.write('sequence\n>>\n'+self.aaseq.get('1.0',END)+'>>\n')
		
		
		if self.val == 1:
			topofile.write('N-terminus: cytoplasm\n')
		elif self.val == 0:
			topofile.write('N-terminus: periplasm\n')
		elif self.val == -1:
			topofile.write('N-terminus: noinfo\n')
		
		
		tmstring=self.tmh.get(1.0,END)
		tm_lst = tmstring.split('\n')
		for entries in tm_lst:
			if entries != '':
				e = entries.split()
				topofile.write('TM\t'+e[0]+'\t'+e[1]+'\t'+e[2]+'\t'+'\n')

		stmstring=self.stmh.get(1.0,END)
		stm_lst = stmstring.split('\n')
		for entries1 in stm_lst:
			if entries1 != '':
				e1 = entries1.split()
				topofile.write('sTM\t'+e1[0]+'\t'+e1[1]+'\t'+e1[2]+'\t'+'\n')
		
		ihstring=self.ih.get(1.0,END)
		ih_lst = ihstring.split('\n')
		for entries2 in ih_lst:
			if entries2 != '':
				e2 = entries2.split()
				topofile.write('IH\t'+e2[0]+'\t'+e2[1]+'\t'+e2[2]+'\t'+'\n')
		
		rlstring=self.rl.get(1.0,END)
		rl_lst = rlstring.split('\n')
		for entries3 in rl_lst:
			if entries3 != '':
				e3 = entries3.split()
				topofile.write('RL\t'+e3[0]+'\t'+e3[1]+'\n')
		
		if self.h1id.get() != '' and self.h2id.get() != '':
			topofile.write('NC\t'+self.h1id.get()+'\t'+self.h2id.get()+'\n')
		
		
		t1=Timer(1,self.topo) # starts after 1 sec the function topo()
		t1.start()
		
		povimage=self.imagedir+'/topoprotein.pov'
		args = [povimage]
		t2 = Timer(2,self.povi,args) # starts after 2 secs the function povi()
		t2.start()


		self.topowid.quit()

	
	
	def pastein(self): # allows to paste in text
		self.aaseq.insert(INSERT, self.aaseq.clipboard_get()) 

	def setval0(self): # value for radiobutton
		self.val = 0

	def setval1(self): # value for radiobutton
		self.val = 1
		
	def topo(self): # modul imagetopo is called and writes a povray file
		imagetopo.createtopo(self.imagedir+'/topology.txt', self.imagedir+'/topoprotein', self.imagedir+'/helixwheel')
		
		
	def povi(self,pi): # modul imagetopo is called and parses with the ray tracer povray the pov file
		name = self.imagedir+'/topoprotein'
		w = 800
		imagetopo.exe_povray(pi,name,w)


def start_topowidget():
	# create a new object of the class Topowidget
	create = Topowidget()

